<?php
	/**
	*Contains all the functions that return Column Arrays for use with Displaying Audit Entries
	*@package OurFleet
	*@copyright Copyright 2006 Web Matrix Pty Ltd & e-fficiency Business Solutions
	*@version 1.0 
	*/

/**
*Returns the Columns for use with State Audit Displays
*@return array
*/
	function getStateColumns(){
		$columns = array(
			array('State ID','stateK'),
			array('State Name','state_name'),
			array('Abbreviation','state_abbr'),
		);
	
		return $columns; 
	}
	
	/**
*Returns the Columns for use with Department Audit Displays
*@return array
*/
	function getDepartmentColumns(){
		$columns = array(
			array('Department ID','departmentK'),
			array('Department Name','name'),
		);
		
		return $columns;
	}
	
	
/**
*Returns the Columns for use with Agent Audit Displays
*@return array
*/
	function getAgentColumns(){
		$columns = array(
			array('Agent ID','agentK'),
			array('Agent Type','agentTypeFK'),
			array('Agent Name','name'),
			array('Address 1','address_one'),
			array('Address 2','address_two'),
			array('City','city'),
			array('Postcode','postcode'),
			array('State','stateFK'),
			array('Phone 1','phone_one'),
			array('Phone 2','phone_two'),
			array('Mobile','phone_mobile'),
			array('Email','email')
		);
		
		return $columns;
	}
	
	/**
*Returns the Columns for use with Insurance Broker Audit Displays
*@return array
*/
	function getBrokerColumns(){
		$columns = array(
			array('Broker ID','insuranceBrokerK'),
			array('Broker Name','name'),
			array('Address 1','address_one'),
			array('Address 2','address_two'),
			array('City','city'),
			array('Post Code','postcode'),
			array('State','stateFK'),
			array('Phone 1','phone_one'),
			array('Phone 2','phone_two'),
			array('Mobile','phone_mobile'),
			array('Email','email'),
			array('Notes','description')
		);
		
		return $columns;
	}
	
	/**
*Returns the Columns for use with Company Location Audit Displays
*@return array
*/
	function getSiteColumns(){
		$columns = array(
			array('Location ID','siteK'),
			array('Name','name'),
			array('Address 1','address_one'),
			array('Address 2','address_two'),
			array('City','city'),
			array('State','stateFK'),
			array('Post Code','postcode'),
		);
		
		return $columns;
	}

/**
*Returns the Columns for use with Vehicle Type Audit Displays
*@return array
*/
	function getVehicleTypeColumns(){
		$columns = array(
			array('Car Type ID','carTypeK'),
			array('Name','typename')
		);
		
		return $columns;
	}

/**
*Returns the Columns for use with Vehicle Manufacturer Audit Displays
*@return array
*/
	function getVehicleManufacturerColumns(){
		$columns = array(
			array('Manufacturer ID','manufacturerK'),
			array('Name','name')
		);
		
		return $columns;
	}

/**
*Returns the Columns for use with Vehicle Model Audit Displays
*@return array
*/	
	function getModelColumns(){
		$columns = array(
			array('Model ID','modelK'),
			array('Manufacturer','manufacturerFK'),
			array('Type','carTypeFK'),
			array('Name','modelname')
		);
		
		return $columns;
	}

/**
*Returns the Columns for use with Lease Audit Displays
*@return array
*/
	function getLeaseColumns(){
		$columns = array(
			array('Lease Date','lease_date'),
			array('Lease Expires','lease_expires'),
			array('Initial Cost','initial_cost'),
			array('Monthly Cost','monthly_cost'),
			array('Other Costs','other_costs')
		);
		
		return $columns;
	}

/**
*Returns the Columns for use with FBT Audit Displays
*@return array
*/
	function getFBTColumns(){
		$columns = array(
			array('FBT Value','fbt_value'),
			array('Date Commenced','date_commenced'),
			array('Date Concluded','date_concluded'),
			array('Private Kms','private_kms'),
			array('Private Days','private_days')
		);
		
		return $columns;
	}

/**
*Returns the Columns for use with Vehicle Fuel Usage Audit Displays
*@return array
*/
	function getFuelColumns(){
		$columns = array(
			array('Amount','amount'),
			array('Cost','cost'),
			array('Card No.','card_no'),
			array('Fuel Date','fuel_date'),
			array('Reference','reference')
		);
		
		return $columns;
	}

/**
*Returns the Columns for use with Odometer Reading Audit Displays
*@return array
*/
	function getOdometreColumns(){
		$columns = array(
			array('Reading Start','reading_start'),
			array('Reading End','reading_end'),
			array('Date Start','date_start'),
			array('Date End','date_end')
		);
		
		return $columns;
	}

/**
*Returns the Columns for use with Incident/Accident Audit Displays
*@return array
*/
	function getIncidentColumns(){
		$columns = array(
			array('Date Time','date_time'),
			array('Location','location'),
			array('Reference','reference'),
			array('Damage Details','damage_details')
		);
		
		return $columns;
	}

/**
*Returns the Columns for use with Damage Audit Displays
*@return array
*/
	function getDamageColumns(){
		$columns = array(
			array('Damage Date','damagedate'),
			array('Obligation #','obligation'),
			array('Reference','reference'),
			array('Description','description')
		);
		
		return $columns;
	}

/**
*Returns the Columns for use with Infringement Audit Displays
*@return array
*/
	function getInfringementColumns(){
		$columns = array(
			array('Number','number'),
			array('Date Time','date_time'),
			array('Cost','cost'),
			array('Description','description')
		);
		
		return $columns;
	}

/**
*Returns the Columns for use with Insurance Audit Displays
*@return array
*/
	function getInsuranceColumns(){
		$columns = array(
			array('Cost','cost'),
			array('Start Date','startdate'),
			array('Expires','expires'),
			array('Description','description')
		);
		
		return $columns;
	}

/**
*Returns the Columns for use with Employee Reimbursment Audit Displays
*@return array
*/
	function getReimbursementColumns(){
		$columns = array(
			array('Date Start','date_start'),
			array('Date End','date_end'),
			array('Amount','amount'),
			array('Description','description')
		);
		
		return $columns;
	}

/**
*Returns the Columns for use with License Type Audit Displays
*@return array
*/
	function getLicenceTypeColumns(){
		$columns = array(
			array('Type Name','typename')
		);
		
		return $columns;
	}

/**
*Returns the Columns for use with Vehicle Audit Displays
*@return array
*/
	function getVehicleColumns(){
		$columns = array(
			array('Date Obtained','date_obtained'),
			array('Reference','reference'),
			array('Initial Odometre','initial_odometer'),
			array('Seats','seats'),
			array('Colour','colour'),
			array('Year','year'),
			array('e-Tag','tag_id')
		);
		
		return $columns;
	}

/**
*Returns the Columns for use with Service Audit Displays
*@return array
*/
	function getServiceRepairs(){
		$columns = array(
			array('Appointment Date','appointmentDate'),
			array('Actual Date','actualDate'),
			array('Odometer Reading','odometerReading'),
			array('Comments','comments')
		);
		
		return $columns;
	}

/**
*Returns the Columns for use with Vehicle Registration Audit Displays
*@return array
*/
	function getRego(){
		$columns = array(
			array('Number','number'),
			array('Rego Type','regotype'),
			array('Start Date','startdate'),
			array('Expires','expires'),
			array('Cost','cost'),
			array('Description','description')
		);
		
		return $columns;
	}

/**
*Returns the Columns for use with Repairs Audit Displays
*@return array
*/
	function getRepairs(){
		$columns = array(
			array('Cost','cost'),
			array('Description','description')
		);
		
		return $columns;
	}

/**
*Returns the Columns for use with Reistration Type Audit Displays
*@return array
*/
	function getRegistrationTypeColumns(){
		$columns = array(
			array('ID','registrationTypeK'),
			array('Type Name','registrationType')
		);
		return $columns;
	}

/**
*Returns the Columns for use with Inclusion Audit Displays
*@return array
*/
	function getGeneralInclusionColumns(){
		$columns = array(
			array('ID','inclusionK'),
			array('Inclusion','name'),
		);
		return $columns;
	}
?>