<?php
  // ===========================================================================
  // eMail class
  // Web Matrix (May, 2004)
  // Gef <gef@webmatrix.net.au>
  // ===========================================================================

  // -------------------------------------------------------------------------
  // Usage:
  //
  // $email = new cEmail("user@example.com", "admin@example.com", "Message Subject", "Message Content");
  // if(!$email->Send()) {
  //   ... Handle failed email sending
  // }
  // -------------------------------------------------------------------------

  // -------------------------------------------------------------------------
  // Email class
  // -------------------------------------------------------------------------
  class cEmail {
  	var $To;
  	var $From;
  	var $Subject;
  	var $HTMLBody;
  	var $TextBody;
  	var $Body;
  	var $Headers;

  	var $Encoding;

  	/*
  	var $Server;
  	var $Username;
  	var $Password;
  	*/

  	var $Defaults;

  	var $ok;

  	function cEmail($to, $from, $subject, $content="") {
  		$this->Defaults = array(
  		"DefaultSubject" => "Default Subject",
  		"XMailer" => "System Notification",
  		"DefaultFrom" => "System Administrator <businesspack@wmxbox.com>",
  		"ReturnPath" => NOTIFY_FROM_EMAIL,
  		"Boundary" => uniqid("000MAILBOUNDRY"),
  		"Encoding" => "7bit",
  		);
  		$this->To = $to;
  		$this->From = (strlen($from) > 0) ? $from : $this->Defaults['DefaultFrom'];
  		$this->Subject = (strlen($subject) > 0) ? $subject : $this->Defaults['DefaultSubject'];
  		$this->TextBody = $content;
  		$this->Encoding = "7bit";
  		$this->Headers = array();

  		$this->ok = 0;
  		$this->CheckOk();
  	}

  	// -------------------------------------------------------------------------
  	// make sure there is enough information to send a valid email
  	// -------------------------------------------------------------------------
  	function CheckOk() {
  		$this->ok = 1;
  		if(! (strlen($this->To) > 0 && strlen(strstr($this->To, "@")) > 0)) {
  			$this->ok = 0;
  		}
  		if(! (strlen($this->From) > 0 && strlen(strstr($this->From, "@")) > 0)) {
  			$this->ok = 0;
  		}
  		if(! (strlen($this->Subject) > 0) ) {
  			$this->ok = 0;
  		}
  		if(! ((strlen($this->TextBody) > 0) || (strlen($this->HTMLBody) > 0)) ) {
  			$this->ok = 0;
  		}
  	}

  	// -------------------------------------------------------------------------
  	// get & set
  	// -------------------------------------------------------------------------
  	function Append($content) {
  		$this->TextBody .= $content;
  	}
  	function Body($content="") {
  		if(strlen($content) > 0) {
  			$this->TextBody = $content;
  		}
  		return $this->TextBody;
  	}
  	function From($from="") {
  		if(strlen($from) > 0) {
  			$this->From = $from;
  		}
  		return $this->From;
  	}
  	function To($to="") {
  		if(strlen($to) > 0) {
  			$this->To = $to;
  		}
  		return $this->To;
  	}
  	function Content($content="") {
  		if(strlen($content) > 0) {
  			$this->TextBody = $content;
  		}
  		return $this->TextBody;
  	}
  	function HTMLBody($content="") {
  		if(strlen($content) > 0) {
  			$this->HTMLBody = $content;
  		}
  		return $this->HTMLBody;
  	}

  	function setEncoding($encoding) {
  		$this->Encoding = $encoding;
  	}
  	function getEncoding() {
  		return $this->Encoding;
  	}

  	// -------------------------------------------------------------------------
  	// AppendHTML()
  	// -------------------------------------------------------------------------
  	function appendHTML($html) {
  		$this->HTMLBody .= $html;
  	}

  	// -------------------------------------------------------------------------
  	// appendHeader()
  	// -------------------------------------------------------------------------
  	function appendHeader($name, $value) {
  		if(strlen($name) > 0) {
  			$name = str_replace("\n", "", $name);
  			$value = str_replace("\n", "", $value);
  			array_push($this->Headers, "$name: $value");
  		}
  	}

  	// -------------------------------------------------------------------------
  	// appendHTMLHeaders()
  	// adds header fields for html content (mixed content)
  	// -------------------------------------------------------------------------
  	function appendHTMLHeaders() {
  		//global $Boundary;
  		array_push($this->Headers, "Content-Type: multipart/alternative; boundary = " . $this->Defaults['Boundary'] . "");
  		array_push($this->Headers, "MIME-Version: 1.0");
  	}

  	// -------------------------------------------------------------------------
  	// Send
  	// -------------------------------------------------------------------------
  	function Send() {
  		global $debugOutput;

  		$this->CheckOk();

  		if($this->ok != 0) {
  			$debugOutput .= "sending email\n";
  			$this->Subject = (strlen($this->Subject) > 0) ? $this->Subject : $this->Defaults['DefaultSubject'];

  			$this->appendHeader("Date", date("r"));
  			if(isset($XMailer) && strlen($XMailer) > 0) {
  				$this->appendHeader("X-Mailer", $this->Defaults['XMailer']);
  			}
  			$this->appendHeader("Return-Path", $this->Defaults['ReturnPath']);
  			if(strlen($this->From) > 0) {
  				$this->appendHeader("From", $this->From);
  			}

  			if((strlen($this->TextBody) == 0) && (strlen($this->HTMLBody) > 0)) {
  				$this->TextBody = strip_tags(str_replace("<br>", "\n", $this->HTMLBody));
  			}

  			if(strlen($this->HTMLBody) > 0) {
  				$debugOutput .= "sending multi-part email\n";
  				$this->appendHTMLHeaders();
  				$newBody = '';
  				$newBody .= "This is a multi-part MIME encoded message.\n\n";
  				$newBody .=	"--".$this->Defaults['Boundary']."\n" .
  				"Content-Type: text/plain; charset=ISO-8859-1\n" .
  				"Content-Transfer-Encoding: 7bit\n\n" .
  				$this->TextBody."\n";
  				$newBody .= "--".$this->Defaults['Boundary']."\n" .
  				"Content-Type: text/html; charset=ISO-8859-1\n";
  				switch($this->Encoding) {
  					case "base64":
  					{
  						$debugOutput .= "Using base64 encoding\n";
  						$newBody .= "Content-Transfer-Encoding: base64\n\n" .
  						chunk_split(base64_encode($this->HTMLBody));
  						break;
  					}
  					default:
  					{
  						$debugOutput .= "Using $this->Encoding encoding\n";
  						$newBody .= "Content-Transfer-Encoding: 7bit\n\n";
  						$newBody .= $this->HTMLBody;
  						break;
  					}
  				}

  				$this->Body = $newBody;
  			} else {
  				$this->appendHeader("Content-type", "text/plain");
  				$this->appendHeader("Content-Transfer-Encoding",  "7bit");
  				$this->Body = $this->TextBody;
  			}

  			if(count($this->Headers) > 0) {
  				$append = implode("\n", $this->Headers);
  				$append .= "\n";
  			}

  			if(@mail($this->To, $this->Subject, $this->Body, $append)) {
  				$debugOutput .= "send succeeded.\n";
  				return 1;
  			}
  			$debugOutput .= "done.\n";
  		}
  		return 0;
  	}

  	// Debug dump
  	function debugDump() {
  		echo "Content-type: text/plain\n\n";
  		echo "<pre>";
  		echo htmlentities(print_r($this,true));
  		echo "</pre>";
  	}

  }
?>
