<?php
/**
*@package OurFleet
*@copyright Copyright 2006 Web Matrix Pty Ltd & e-fficiency Business Solutions
*@version 1.0 
*/

/**
*@version 1.0
*/
class c_Audit{
	var $tableName;
	var $tablePrimaryKey;
	var $primaryKeyValue;
	var $database;
	var $fields;
	var $values;
	
	var $mdate;
	var $muser;
	
	function c_Audit($tableName, $tablePrimaryKeyName, $modifiedBy, $auditType=1){
		$fields = array();
		$values = array();
		
		if(!isset($tableName) || strlen(trim($tableName))==0){
			trigger_error('No Table Name Supplied for Audit', E_USER_ERROR);
		}else{
			$this->tableName = $tableName;
		}
		
		if(!isset($tablePrimaryKeyName) || strlen(trim($tablePrimaryKeyName))==0){
			trigger_error('No Table Name Supplied for Audit', E_USER_ERROR);
		}else{
			$this->tablePrimaryKey = $tablePrimaryKeyName;
		}
		
		$this->retrieveFieldInfo();
		
		$this->mdate = date('Y-m-d H:i:s', strtotime("now"));
		$this->muser = $modifiedBy;
		$this->auditType = $auditType;
	}	
	
	function retrieveFieldInfo(){
		$sql = 'DESCRIBE '.$this->tableName;
		
		$res = dbQuery($sql);
		
		if(!$res){
			debug(dbError($sql));
		} else{
			if(dbNumRows($res)>0){
				while($field = dbFetchAssoc($res)){
					$this->fields[$field['Field']] = ''; 
				}
				dbFreeResult($res); 			
			}
		}
		return true;
	}	
	
	function loadRow($rowId){
		$this->fields[$this->tablePrimaryKey] = $rowId;
		$sql = 'SELECT * FROM '.$this->tableName.' WHERE '.$this->tablePrimaryKey.' = '.$this->fields[$this->tablePrimaryKey];
		
		$res = dbQuery($sql);
		
		if(!$res){
			debug(dbError($sql));
		}else{
			if(dbNumRows($res)>0){
				$row = dbFetchAssoc($res);
				
				foreach($row as $key => $value){
					$this->fields[$key] = $value;
				}
			}
		}
		$this->fields['mdate'] = $this->mdate;
		$this->fields['mod_by'] = $this->muser;
		$this->fields['audit_type'] = $this->auditType;
	}	
	
	function outputFieldInfo(){
		echo print_r($this->fields);
	}	
	
	function runAudit(){
		$fields = array_keys($this->fields);
		$values = $this->fields;
		
		
		$sql = 'INSERT INTO '.$this->tableName.'_Audit('.implode($fields,',').') VALUES ("'.implode($values,'","').'")';
		
		dbQuery($sql);
		return dbInsertId();
	}
	
	function loadAudit($rowK){
		$this->fields[$this->tablePrimaryKey] = $rowK;
		$sql = 'SELECT * FROM '.$this->tableName.'_Audit WHERE '.$this->tablePrimaryKey.'='.$this->fields[$this->tablePrimaryKey].' ORDER BY mdate DESC';
		
		$res = dbQuery($sql);
		$results = array();
		
		if(!$res){
			echo dbError($sql);
		}else{
			//echo dbNumRows($res).' rows found<br/>'; 
			while($row = dbFetchAssoc($res)){
				//echo print_r($row).'<br/><br/>';
				$results[] = $row;
			}
		}
		
		return $results;
	}
	
}
?>