<?php
/**
*@package OurFleet
*@copyright Copyright 2006 Web Matrix Pty Ltd & e-fficiency Business Solutions
*@version 1.0 
*/

/**
*@version 1.0
*/
  class cInsurance {
	 var $insuranceK;
	 var $vehicleFK;
	 var $insuranceBrokerFK;
	 var $description;
	 var $cost;
	 var $startdate;
	 var $expires;
	 var $modified_date;
	 var $modified_by;  
	 var $policy_number;
  
    function cInsurance($id=0) {
      if($id != 0) {
        $this->loadById($id);
      } else {
        $this->reset();
      }
    }
    
    function get($key) {
      if(isset($this->$key)) {
        return $this->$key;
      } else {
        return false;
      }
    }
    
    function loadById($id) {
    	$sql = 'select * from tblInsurance WHERE insuranceK=\''.dbEscapeString($id).'\'';
      
      $res = dbQuery($sql);
      if(!$res) {
        debug(dbError($sql));
      } else {
        if(dbNumRows($res) > 0) {
			$row = dbFetchAssoc($res);
			$row['startdate'] = substr($row['startdate'],0,10); 
			$row['expires'] = substr($row['expires'],0,10);          
			$row['modified_date'] = substr($row['modified_date'],0,10);
          
          array_map_to_this($row, $this);
        } else {
          $this->reset();
        }
        dbFreeResult($res);
      }
    }

	function loadByVehicleId($id) {
    	$sql = 'select * from tblInsurance WHERE vehicleFK=\''.dbEscapeString($id).'\'';
      
      $res = dbQuery($sql);
      if(!$res) {
        debug(dbError($sql));
      } else {
        if(dbNumRows($res) > 0) {
			$row = dbFetchAssoc($res);
			$row['startdate'] = substr($row['startdate'],0,10); 
			$row['expires'] = substr($row['expires'],0,10); 
			$row['modified_date'] = substr($row['modified_date'],0,10);
          
          array_map_to_this($row, $this);
        } else {
          $this->reset();
        }
        dbFreeResult($res);
      }
    }
    
    function loadPosted() {
    	global $p;
		
	 	$this->insuranceK = (isset($p->insuranceK) ? $p->insuranceK : '' );
		$this->vehicleFK = (isset($p->vehicleFK) ? $p->vehicleFK : '' );
		$this->insuranceBrokerFK = (isset($p->insuranceBrokerFK) ? $p->insuranceBrokerFK : '' );
		$this->description = (isset($p->description) ? $p->description : '' );
		$this->cost = (isset($p->cost) ? $p->cost : '' );
		$this->startdate = (isset($p->startdate) ? $p->startdate : '' );
		$this->expires = (isset($p->expires) ? $p->expires : '' );

		$this->modified_date = (isset($p->modified_date) ? $p->modified_date : '' );
	 	$this->modified_by = (isset($p->modified_by) ? $p->modified_by : '');
	 	$this->policy_number = (isset($p->policy_number) ? $p->policy_number : '');           	
    	
    }
    
    function validate() {
		global $invalidFields;
		$invalid = array();
		      
		if($this->insuranceBrokerFK==0){
			$invalid['insuranceBrokerFK'] = 'Please select an Insurance Broker';
		}  

		if($this->vehicleFK==0){
			$invalid['vehicleFK'] = 'Please select a Vehicle';
		}  

		if(empty($this->description)){
			$invalid['description'] = 'Please enter a Description';
		}  
	
		if(strlen(trim($this->policy_number))==0){
			$invalid['policy_number'] = 'Please enter a Policy Number';
		}  

		if($this->cost==0){
			$invalid['cost'] = 'Please enter a Cost';
		}  

		if($this->startdate==0){
			$invalid['startdate'] = 'Please select a Start Date';
		}  

		if($this->expires==0){
			$invalid['expires'] = 'Please select an Expiry Date';
		}  

      if(count($invalid) > 0) {
        $invalidFields = array_merge($invalidFields, $invalid);
        return false;
      }
      return true;
    }
    
    function reset() {
	 	$this->insuranceK=0;
	 	$this->vehicleFK=0;
	 	$this->insuranceBrokerFK=0;
	 	$this->description='';
	 	$this->cost='';
	 	$this->startdate='';
	 	$this->expires='';
	 	$this->modified_date='';
	 	$this->modified_by=0; 
	 	$this->policy_number = '';
    }
    
  }
  
?>