<?php
 /**
*@package OurFleet
*@copyright Copyright 2006 Web Matrix Pty Ltd & e-fficiency Business Solutions
*@version 1.0 
*/

/**
*@version 1.0
*@author Daniel
*/
  
  class cOdometre {
  		// Class Variables
		//Please note:  The variable names must be exactly the same as the appropriate database field names  		
  		var $odometreK;
  		var $employeeFK;
		var $departmentFK;
  		var $vehicleFK;
  		var $reading_start;
  		var $reading_end;
  		var $date_start;
  		var $date_end;
  		var $private;
  		var $modified_date;
  		var $modified_by; 

    function cOdometre($id=0) {
      if($id != 0) {
        $this->loadById($id);
      } else {
        $this->reset();
      }
    }
    
    function get($key) {
      if(isset($this->$key)) {
        return $this->$key;
      } else {
        return false;
      }
    }
    
    function loadById($id) {
    	//create  the sql Statement
    	//remember to use dbEscapeString(String $stringToEscape) to escape striing in supplied $id
		$sql = 'SELECT * FROM tblOdometre WHERE tblOdometre.odometreK = \''.dbEscapeString($id).'\' limit 0,1';    	
    	
      $res = dbQuery($sql);
      if(!$res) {
        debug(dbError($sql));
      } else {
        if(dbNumRows($res) > 0) {
          $row = dbFetchAssoc($res);
		  $row['date_start'] = substr($row['date_start'],0,10);         
         $row['date_end'] = substr($row['date_end'],0,10);
		  $row['modified_date'] = substr($row['modified_date'],0,10);

          array_map_to_this($row, $this);
        } else {
          $this->reset();
        }
        dbFreeResult($res);
      }
    }
    
    function loadPosted() {
		global $p;    
    
    	//load the class variables from the posted values
    	$this->odometreK = (isset($p->odometreK) ? $p->odometreK : '');
		$this->employeeFK = (isset($p->employeeFK) ? $p->employeeFK : '');
		$this->departmentFK = (isset($p->departmentFK) ? $p->departmentFK : '');
		$this->vehicleFK = (isset($p->vehicleFK) ? $p->vehicleFK : '');
		$this->reading_start = (isset($p->reading_start) ? $p->reading_start : '');
		$this->reading_end = (isset($p->reading_end) ? $p->reading_end : '');
		$this->date_start = (isset($p->date_start) ? $p->date_start : '');
		$this->date_end = (isset($p->date_end) ? $p->date_end : '');
		$this->private = (isset($p->private) ? $p->private : '');
		$this->modified_date = (isset($p->modified_date) ? $p->modified_date : '');
		$this->modified_by = (isset($p->modified_by) ? $p->modified_by : '');

      
      //example for loading a date
      if(isset($p->year) && isset($p->month) && isset($p->day)) {
        $date = $p->year."-".str_pad($p->month, 2, '0', STR_PAD_LEFT)."-".str_pad($p->day, 2, '0', STR_PAD_LEFT);
      } else if(isset($p->date_obtained) && strlen($p->date_obtained) > 0) {
        $date = $p->date_obtained;
      } else {
        $date = '';
      }
      $this->dateField = $date;
    }
    
    function validate() {
		global $invalidFields;
		$invalid = array();

		if($this->odometreK != 0){
			$sql = 'SELECT COUNT(*) as lCount FROM tblOdometre WHERE odometreK='. dbEscapeString($this->odometreK);
			$res = dbQuery($sql);
			if(!$res) {
				debug(dbError($sql));
			} else {
				if(dbNumRows($res) > 0) {
					$row = dbFetchAssoc($res);
					if($row['lCount']==0){
						$invalid['odometreK'] = 'The Selected Odometre Readings could not be found';
					}
				}
				dbFreeResult($res);
			}
		}  

		if($this->vehicleFK == 0){
			$invalid['vehicleFK'] = 'Please enter a valid Vehicle ID';
		}

		if($this->employeeFK == 0){
			$invalid['employeeFK'] = 'Please select an Employee';
		}

		if(!isset($this->departmentFK) || $this->departmentFK==0){
			$invalid['departmentFK'] = 'Please select a Department';
		}
		
		if(strlen(trim($this->reading_start)) == 0){
			$invalid['reading_start'] = 'Please enter a Start Reading';
		} else if(strlen($this->reading_start) > 10) {
			$invalid['seats'] = "Start Reading exeeds the maximum field length";
		} else{
			if(!is_numeric($this->reading_start)) {
				$invalid['reading_start'] = 'Start Reading is not a number';
			}

			if(strlen(trim($this->reading_end)) != 0 && $this->reading_start > $this->reading_end){
				$invalid['reading_start'] = 'Start Reading is greater than End Reading';
				$invalid['reading_end']='';
			}
		}  
		
		if(strlen(trim($this->reading_end)) == 0){
			$invalid['reading_end'] = 'Please enter an End Reading';
		} else if(strlen($this->reading_end) > 10) {
			$invalid['reading_end'] = "End Reading exeeds the maximum field length";
		} else{
			if(!is_numeric($this->reading_end)) {
				$invalid['reading_end'] = 'End Reading is not a number';
			}
		}   

		if(strlen(trim($this->reading_start)) != 0 && strlen(trim($this->reading_end)) != 0){
			$sql = 'SELECT COUNT(*) as lCount FROM tblOdometre WHERE ((reading_start BETWEEN '.dbEscapeString($this->reading_start).' AND '.dbEscapeString($this->reading_end).') OR (reading_end-1 BETWEEN '.dbEscapeString($this->reading_start).' AND '.dbEscapeString($this->reading_end).')) OR (('.dbEscapeString($this->reading_start).' BETWEEN reading_start AND reading_end-1) OR ('.dbEscapeString($this->reading_end).' BETWEEN reading_start AND reading_end-1)) AND vehicleFK='.$this->vehicleFK;
			
			$res = dbQuery($sql);
			if(!$res) {
				debug(dbError($sql));
			} else {
				if(dbNumRows($res) > 0) {
					$row = dbFetchAssoc($res);
					if($row['lCount']!=0){
						$invalid['reading_end'] = 'End Reading overlaps an existing reading.';
						$invalid['reading_start'] = 'Start Reading overlaps an existing reading.';
					}
				}
				dbFreeResult($res);
			}
		}

		if(strlen(trim($this->date_start)) == 0){
			$invalid['date_start'] = 'Please enter a Start Date';
		} else{
			if(strlen(trim($this->date_end)) != 0 && $this->date_end < $this->date_start){
				$invalid['date_start'] = 'End Date is before the Start Date';
				$invalid['date_end'] = '';
			}
		} 
		
		if(strlen(trim($this->date_end)) == 0){
			$invalid['date_end'] = 'Please enter an End Date';
		}     

		if(count($invalid) > 0) {
			$invalidFields = array_merge($invalidFields, $invalid);
			return false;
		}
		return true;
    }
    
    function reset() {
      $this->odometreK = 0;
      $this->employeeFK = 0;
	  $this->departmentFK = 0;
      $this->vehicleFK = 0;
      $this->reading_start = '';
      $this->reading_end = '';
      $this->date_start = '';
      $this->date_end = '';
      $this->private = '';
      $this->modified_date = '';
      $this->modified_by = ''; 

    }
    
  }
  
  
  
?>