<?php
 /**
*@package OurFleet
*@copyright Copyright 2006 Web Matrix Pty Ltd & e-fficiency Business Solutions
*@version 1.0 
*/

/**
*@version 1.0
*/
  
  class cPager {
    var $numItems;
    var $perPage;
    var $start;
    var $enabled;
    
    function cPager($itemsPerPage) {
    	
      $this->perPage = $itemsPerPage;
      $this->start = 0;
      $this->page = 0;
      $this->numItems = 0;
      $this->enabled = true;
      
      if(isset($_GET['page'])) {
      	
        if($_GET['page'] > 0) {
          $this->page = $_GET['page'] - 1;
        } else {
          $this->page = 0;
        }
      } else {
        $this->page = 0;
      }
      //$this->updatePaging();
    }
    
    function setMax($numRows) {
      if(!empty($numRows)) {
        $this->numItems = $numRows;
      } else {
        $this->numItems = 0;
      }
    }
    
    function updatePaging() {
    	$maxPages = rounding($this->numItems/ $this->perPage,1);
    	
      $this->page = ($this->page > $maxPages) ? $maxPages : $this->page;
      
      if($this->page > 0) {
      
        $this->start = ($this->page * $this->perPage);
      }
      
      $this->start = ($this->start >= 0) ? $this->start : 0;
    }
    
    function numPages() {
      if($this->numItems > 0 && $this->itemsPerPage > 0) {
        return floor($this->numItems / $this->perPage);
      } else {
        return 1;
      }
    }
    
    function disable() {
      $this->enabled = false;
    }
    
    function enable() {
      $this->enabled = true;
    }
    
    function draw($pageRange, $link='') {
    	if($pageRange % 2==0){
    		$pageRange = $pageRange/2;
    	}else{
    		$pageRange = ($pageRange-1)/2;
    	}
    	
    	$maxPages = rounding($this->numItems/ $this->perPage,1);
    	if($maxPages<2){
    		$this->disable();
    	}
      if($this->enabled) {
      	$currentPage = ($this->page+1);
      	
      	
      	$startPage = ($currentPage-$pageRange)<=0?1:$currentPage-$pageRange;
      	$endPage = ($currentPage+$pageRange)>$maxPages?$maxPages:$currentPage+$pageRange;
      	$content = '<div class="pagingContainer" align="center" width="100%">';
      	$content .= '<div class="pagingNav">';
      	if($startPage>1){
      		$content .='<div class="pagingNavItem">';
      		$content .= '<a href="'.$link.'&page=1">1</a>';
      		$content .='</div>';
      		$content .='<div class="pagingNavItem">';
      		$content .= '...';
      		$content .='</div>';
      	}
      	for($i=$startPage;$i<$endPage+1;$i++){
      		$content .='<div class="pagingNavItem">';
      		if(!$link){
      		
      		}else{
      			$content .= '<a href="'.$link.'&page='.$i.'">'.$i.'</a>';
      		}
      		
      		$content .= '</div>';
      	}
      	if($endPage<$maxPages){
      	$content .='<div class="pagingNavItem">';
      		$content .= '...';
      		$content .='</div>';
      		$content .='<div class="pagingNavItem">';
      		$content .= '<a href="'.$link.'&page='.$maxPages.'">'.$maxPages.'</a>';
      		$content .='</div>';
      	}
      	$content .='</div>';
      	$content .='</div>';
      	
        return $content;//'Showing Page '.$currentPage.' of '.$maxPages;
      }
    }
    
  }
  
?>