<?php
 /**
*@package OurFleet
*@copyright Copyright 2006 Web Matrix Pty Ltd & e-fficiency Business Solutions
*@version 1.0 
*/

/**
*@version 1.0
*/
  
  class cRego {
	 var $regoK;
	 var $vehicleFK;
	 var $number;
	 var $regotype;
	 var $stateFK;
	 var $startdate;
	 var $expires;
	 var $cost;
	 var $description;
	 var $modified_date;
	 var $modified_by;  
  
    function cRego($id=0) {
      if($id != 0) {
        $this->loadById($id);
      } else {
        $this->reset();
      }
    }
    
    function get($key) {
      if(isset($this->$key)) {
        return $this->$key;
      } else {
        return false;
      }
    }
    
    function loadById($id) {
    	$sql = 'select * from tblRego WHERE regoK=\''.dbEscapeString($id).'\'';
      
      $res = dbQuery($sql);
      if(!$res) {
        debug(dbError($sql));
      } else {
        if(dbNumRows($res) > 0) {
          $row = dbFetchAssoc($res);
          //fix the issue relating to having the time at the end of the date_obtained
			//due to the time the system does not reconise it's date and uses the current system time instead
			$row['startdate'] = substr($row['startdate'],0,10);         
         $row['expires'] = substr($row['expires'],0,10);
          
          array_map_to_this($row, $this);
        } else {
          $this->reset();
        }
        dbFreeResult($res);
      }
    }

	function loadByVehicleId($id) {
    	$sql = 'select * from tblRego WHERE vehicleFK=\''.dbEscapeString($id).'\'';
      
      $res = dbQuery($sql);
      if(!$res) {
        debug(dbError($sql));
      } else {
        if(dbNumRows($res) > 0) {
          $row = dbFetchAssoc($res);
          //fix the issue relating to having the time at the end of the date_obtained
			//due to the time the system does not reconise it's date and uses the current system time instead
			$row['startdate'] = substr($row['startdate'],0,10);         
         $row['expires'] = substr($row['expires'],0,10);
          
          array_map_to_this($row, $this);
        } else {
          $this->reset();
        }
        dbFreeResult($res);
      }
    }
    
    function loadPosted() {
    	global $p;
		
		$this->regoK = (isset($p->regoK) ? $p->regoK : 0);
	 	$this->vehicleFK = (isset($p->vehicleFK) ? $p->vehicleFK : 0);
	 	$this->number = (isset($p->number) ? $p->number : '');
	 	$this->regotype = (isset($p->regotype) ? $p->regotype : '');
	 	$this->stateFK = (isset($p->stateFK) ? $p->stateFK : 0);
	 	$this->startdate = (isset($p->startdate) ? $p->startdate : '');	 		 	
	 	$this->expires = (isset($p->expires) ? $p->expires : '');
	 	$this->cost = (isset($p->cost) ? $p->cost : '');
	 	$this->description = (isset($p->description) ? $p->description : '');
	 	$this->modified_date = (isset($p->modified_date) ? $p->modified_date : '' );
	 	$this->modified_by = (isset($p->modified_by) ? $p->modified_by : '');      	
    	
    }
    
    function validate() {
		global $invalidFields;
		$invalid = array();

		if($this->regoK != 0){
			$sql = 'SELECT COUNT(*) as lCount FROM tblRego WHERE regoK='. dbEscapeString($this->regoK);
			$res = dbQuery($sql);
			if(!$res) {
				debug(dbError($sql));
			} else {
				if(dbNumRows($res) > 0) {
					$row = dbFetchAssoc($res);
					if($row['lCount']==0){
						$invalid['regoK'] = 'The Selected Registration could not be found';
					}
				}
				dbFreeResult($res);
			}
		}      
      
		if($this->vehicleFK==0){
			$invalid['vehicleFK'] = 'No Vehicle was supplied.  Registration details must be attached to a valid Vehicle';
		}      
		
		if(strlen(trim($this->number))==0){
			$invalid['number'] = 'Please enter the Registration Number';
		} else if(strlen($this->number) > 45) {
			$invalid['number'] = "Number of seats exeeds the maximum field length";
		}
		
		if(strlen(trim($this->regotype))==0){
			$invalid['regotype'] = 'Please enter a Registration type';
		} else if(strlen($this->regotype) > 50) {
			$invalid['regotype'] = "Rego Type exeeds the maximum field length";
		}
      
      
		if($this->stateFK == 0){
			$invalid['stateFK'] = 'Please select the State the Vehicle is Registered in'; 
		}      
      $startDate='';
		if(strlen(trim($this->startdate))==0){
			$invalid['startdate'] = 'You must enter a valid Start Date';
		}else{
			if(!$startDate = strtotime($this->startdate)){
				$invalid['startdate'] = 'You must enter a valid Start Date';
			}
		}
      $endDate='';
		if(strlen(trim($this->expires))==0){
			$invalid['expires'] = 'You must enter a valid Expiry Date';
		}else{
			if(!$endDate = strtotime($this->startdate)){
				$invalid['expires'] = 'You must enter a valid Expiry Date';
			}
		}      
      
		if(strlen(trim($this->cost)) == 0){
			$invalid['cost'] = 'Please enter the Cost of Registration';
		} else if(strlen($this->cost) > 14) {
			$invalid['cost'] = "Cost price exeeds the maximum field length";
		}else{
			if(!is_numeric($this->cost)){
				$invalid['cost'] = 'Please enter a valid Numeric value for the Registration Cost';
			}
		}
      
      if(strlen(trim($startDate))>0 && strlen(trim($endDate))>0){
      	if($endDate < $startDate){
      		$invalid['startdate'] = 'The Expiry Date must be later than the Start date';
      		$invalid['expires'] = '';
      	}
      }
      
		      
      if(count($invalid) > 0) {
        $invalidFields = array_merge($invalidFields, $invalid);
        return false;
      }
      return true;
    }
    
    function reset() {
    	$this->regoK=0;
	 	$this->vehicleFK=0;
	 	$this->number='';
	 	$this->regotype='';
	 	$this->stateFK=0;
	 	$this->startdate='';
	 	$this->expires='';
	 	$this->cost=0;
	 	$this->description='';
	 	$this->modified_date='';
	 	$this->modified_by=0; 
    }
    
  }
  
?>