<?php
 /**
*@package OurFleet
*@copyright Copyright 2006 Web Matrix Pty Ltd & e-fficiency Business Solutions
*@version 1.0 
*/

/**
*@version 1.0
*/
  
  class cReimbursement {
	 var $reimbursementK;
	 var $employeeFK;
	 var $vehicleFK;
	 var $description;
	 var $date_start;
	 var $date_end;
	 var $amount;
	 var $totalkms;
	 var $modified_date;
	 var $modified_by;  
  
    function cReimbursement($id=0) {
      if($id != 0) {
        $this->loadById($id);
      } else {
        $this->reset();
      }
    }
    
    function get($key) {
      if(isset($this->$key)) {
        return $this->$key;
      } else {
        return false;
      }
    }
    
    function loadById($id) {
    	$sql = 'select * from tblReimbursements WHERE reimbursementK=\''.dbEscapeString($id).'\'';
      
      $res = dbQuery($sql);
      if(!$res) {
        debug(dbError($sql));
      } else {
        if(dbNumRows($res) > 0) {
			$row = dbFetchAssoc($res);
			$row['date_start'] = substr($row['date_start'],0,10); 
			$row['date_end'] = substr($row['date_end'],0,10);          
			$row['modified_date'] = substr($row['modified_date'],0,10);
          
          array_map_to_this($row, $this);
        } else {
          $this->reset();
        }
        dbFreeResult($res);
      }
    }

	function loadByVehicleId($id) {
    	$sql = 'select * from tblReimbursements WHERE vehicleFK=\''.dbEscapeString($id).'\'';
      
      $res = dbQuery($sql);
      if(!$res) {
        debug(dbError($sql));
      } else {
        if(dbNumRows($res) > 0) {
			$row = dbFetchAssoc($res);
			$row['date_start'] = substr($row['date_start'],0,10); 
			$row['date_end'] = substr($row['date_end'],0,10); 
			$row['modified_date'] = substr($row['modified_date'],0,10);
          
          array_map_to_this($row, $this);
        } else {
          $this->reset();
        }
        dbFreeResult($res);
      }
    }
    
    function loadPosted() {
    	global $p;
		
		$this->reimbursementK = (isset($p->reimbursementK) ? $p->reimbursementK : '' );
		$this->employeeFK = (isset($p->employeeFK) ? $p->employeeFK : '' );
		$this->vehicleFK = (isset($p->vehicleFK) ? $p->vehicleFK : '' );
		$this->description = (isset($p->description) ? $p->description : '' );
		$this->date_start = (isset($p->date_start) ? $p->date_start : '' );
		$this->date_end = (isset($p->date_end) ? $p->date_end : '' );
		$this->amount = (isset($p->amount) ? $p->amount : 0 );
		$this->totalkms = (isset($p->totalkms) ? $p->totalkms : 0 );		
		$this->modified_date = (isset($p->modified_date) ? $p->modified_date : '' );
	 	$this->modified_by = (isset($p->modified_by) ? $p->modified_by : '');      	
    	
    }
    
    function validate() {
		global $invalidFields;
		$invalid = array();
		      
		if($this->employeeFK==0){
			$invalid['employeeFK'] = 'Please select an Employee';
		}  

		if($this->vehicleFK==0){
			$invalid['vehicleFK'] = 'Please select a Vehicle';
		}  

		if(empty($this->description)){
			$invalid['description'] = 'Please enter a Description';
		}  

		if($this->date_start==0){
			$invalid['date_start'] = 'Please select a Start Date';
		} else{
			$year = DATE('Y',strtotime($this->date_start));
			$fbtDateEnd = strtotime('March 31, '.$year);
			$datestart =strtotime($this->date_start); 
			
			if($datestart > $fbtDateEnd){
				$year = DATE('Y',strtotime($this->date_end));
				$fbtDateEnd = strtotime('March 31, '.$year);
			}
			
			if(($datestart < $fbtDateEnd) && strtotime($this->date_end) > $fbtDateEnd){
				$invalid['date_start'] = 'The FBT year ends March 31, please divide the reimbursment you are attempting to enter into 2 entries, one Ending March 31st and one beginning April 1st.';
				$invalid['date_end'] = '';
			}
		}

		if($this->date_end==0){
			$invalid['date_end'] = 'Please select an End Date';
		}  

		if($this->amount==0){
			$invalid['amount'] = 'Please enter an Amount';
		}  
	
		if($this->totalkms==0){
			$invalid['totalkms'] = 'Please enter the Total KMs';
		}


      if(count($invalid) > 0) {
        $invalidFields = array_merge($invalidFields, $invalid);
        return false;
      }
      return true;
    }
    
    function reset() {
	 	$this->reimbursementK='';
	 	$this->employeeFK='';
	 	$this->vehicleFK='';
	 	$this->description='';
	 	$this->date_start='';
	 	$this->date_end='';
	 	$this->amount='';
	 	$this->totalkms='';
	 	$this->modified_date='';
	 	$this->modified_by=0; 
    }
    
  }
  
?>