<?php
 /**
*@package OurFleet
*@copyright Copyright 2006 Web Matrix Pty Ltd & e-fficiency Business Solutions
*@version 1.0 
*/

/**
*@version 1.0
*/
  
  class cRepairs {
  		// Class Variables
		//Please note:  The variable names must be exactly the same as the appropriate database field names  		
		var $repairsK;
		var $agentFK;
		var $description;
		var $cost;
		var $modified_date;
		var $modified_by;
		var $serviceRepairFK;
    
    function cRepairs($id=0) {
      if($id != 0) {
        $this->loadById($id);
      } else {
        $this->reset();
      }
    }
    
    function get($key) {
      if(isset($this->$key)) {
        return $this->$key;
      } else {
        return false;
      }
    }
    
    function loadById($id) {
    	//create  the sql Statement
    	//remember to use dbEscapeString(String $stringToEscape) to escape striing in supplied $id
		$sql = 'SELECT * FROM tblRepairs WHERE tblRepairs.repairsK = \''.dbEscapeString($id).'\' limit 0,1';    	
    	
      $res = dbQuery($sql);
      if(!$res) {
		  return false;
        debug(dbError($sql));
      } else {
        if(dbNumRows($res) > 0) {
          $row = dbFetchAssoc($res);
		  $row['modified_date'] = substr($row['modified_date'],0,10);

          array_map_to_this($row, $this);
		  return true;
        } else {
          $this->reset();
		  return false;
        }
        dbFreeResult($res);
      }
    }
    
    function loadPosted() {
		global $p;    
    
    	//load the class variables from the posted values
    	$this->repairsK = (isset($p->repairsK) ? $p->repairsK : '');
		$this->agentFK = (isset($p->agentFK) ? $p->agentFK : '');
		$this->description = (isset($p->description) ? $p->description : '');
		$this->cost = (isset($p->cost) ? $p->cost : '');
		$this->modified_date = (isset($p->modified_date) ? $p->modified_date : '');
		$this->modified_by = (isset($p->modified_by) ? $p->modified_by : '');
		$this->serviceRepairFK = (isset($p->serviceRepairFK) ? $p->serviceRepairFK : '');

      
      //example for loading a date
      if(isset($p->year) && isset($p->month) && isset($p->day)) {
        $date = $p->year."-".str_pad($p->month, 2, '0', STR_PAD_LEFT)."-".str_pad($p->day, 2, '0', STR_PAD_LEFT);
      } else if(isset($p->date_obtained) && strlen($p->date_obtained) > 0) {
        $date = $p->date_obtained;
      } else {
        $date = '';
      }
      $this->dateField = $date;
    }
    
    function validate() {
		global $invalidFields;
		$invalid = array();
		//example for validation
		if($this->agentFK == 0){
			$invalid['agentFK'] = 'Please select an Agent';
		}  

		if(strlen(trim($this->description)) == ''){
			$invalid['description'] = 'Please enter a Description';
		}

		if(strlen(trim($this->cost)) == 0){
			$invalid['cost'] = 'Please enter the Cost of Repairs';
		}elseif(!is_numeric($this->cost)){
			$invalid['cost'] = 'Please enter a valid Price value for the Repairs Cost';
		}

		if(count($invalid) > 0) {
			$invalidFields = array_merge($invalidFields, $invalid);
			return false;
		}
		return true;
    }
    
    function reset() {
      $this->repairsK = 0;
      $this->agentFK = 0;
      $this->description = '';
      $this->cost = 0;
      $this->modified_date = '';
      $this->modified_by = 0;
      $this->serviceRepairFK = 0;

    }
    
  }
  
?>