<?php
  /**
*@package OurFleet
*@copyright Copyright 2006 Web Matrix Pty Ltd & e-fficiency Business Solutions
*@version 1.0 
*/

/**
*@version 1.0
*/
  
  class cVehicle {
    var $vehicleK;
    var $siteFK;
    var $modelFK;
    var $date_obtained;
    var $reference;
    var $initial_odometer;
    var $seats;
    var $colour;
    var $year;
    var $tag_id;
	var $archived;
	var $insured;
	var $regoK;
	var $odometer;
	var $fuelcardID;
	var $CostCentreFK;
    
    function cVehicle($id=0) {
      if($id != 0) {
        $this->loadById($id);
      } else {
        $this->reset();
      }
    }
    
    function get($key) {
      if(isset($this->$key)) {
        return $this->$key;
      } else {
        return false;
      }
    }
    
    function loadById($id) {
      $sql  = 'select v.*, ct.typename, man.name as manufacturerName, model.modelname, s.name as siteName, r.number, r.regoK ';
      $sql .= 'from tblVehicle v ';
      $sql .= 'inner join tblModel model on (model.modelK = v.modelFK) ';
      $sql .= 'inner join tblManufacturer man on (man.manufacturerK = model.manufacturerFK) ';
      $sql .= 'inner join tblCarType ct on (ct.carTypeK = model.carTypeFK) ';
      $sql .= 'inner join tblSite s on (v.siteFK = s.siteK) ';
      $sql .= 'left outer join tblRego r on (r.vehicleFK = v.vehicleK) ';
      $sql .= 'where v.vehicleK = \''.dbEscapeString($id).'\' ';
      $sql .= 'limit 0,1 ';
      
       $sql  = 'select v.*, ct.typename,  man.name as manufacturerName, model.modelname, s.name as siteName, r.number , r.regoK';
  $sql .= '      ,concat(man.name, " ", model.modelname, " - ", ct.typename) as model_long_name ';
  $sql .= ', insuranceK as insured ';
  $sql .= 'from tblVehicle v ';
  $sql .= 'inner join tblModel model on (model.modelK = v.modelFK) ';
  $sql .= 'inner join tblManufacturer man on (man.manufacturerK = model.manufacturerFK) ';
  $sql .= 'inner join tblCarType ct on (ct.carTypeK = model.carTypeFK) ';
  $sql .= 'inner join tblSite s on (v.siteFK = s.siteK) ';
  $sql .= 'left outer join tblRego r on (r.vehicleFK = v.vehicleK) ';
  $sql .= 'left outer join tblInsurance i on(v.vehicleK = i.vehicleFK) ';
  	$sql .= 'where v.vehicleK = \''.dbEscapeString($id).'\' ';
  	$sql .= 'limit 0,1 ';
      $res = dbQuery($sql);
      if(!$res) {
        debug(dbError($sql));
      } else {
        if(dbNumRows($res) > 0) {
          $row = dbFetchAssoc($res);
          //fix the issue relating to having the time at the end of the date_obtained
			//due to the time the system does not reconise it's date and uses the current system time instead
			$row['date_obtained'] = substr($row['date_obtained'],0,10);         
          
          array_map_to_this($row, $this);
        } else {
          $this->reset();
        }
        dbFreeResult($res);
      }
    }
    
    function loadPosted() {
    	global $p;
      $this->vehicleK = (isset($p->vehicleK) ? $p->vehicleK : '');
      $this->siteFK = (isset($p->siteFK) ? $p->siteFK : '');
      $this->modelFK = (isset($p->modelFK) ? $p->modelFK : '');
      $this->identifier = (isset($p->identifier) ? $p->identifier : '');
      //$this->reference = (isset($p->reference) ? $p->reference : '');
      $this->initial_odometer = (isset($p->initial_odometer) ? $p->initial_odometer : '');
      $this->seats = (isset($p->seats) ? $p->seats : '');
      $this->colour = (isset($p->colour) ? $p->colour : '');
      $this->year = (isset($p->year) ? $p->year : '');
      $this->tag_id = (isset($p->tag_id) ? $p->tag_id : '');
	  $this->archived = (isset($p->archived) ? $p->archived : '');
      
      if(isset($p->year) && isset($p->month) && isset($p->day)) {
        $date = $p->year."-".str_pad($p->month, 2, '0', STR_PAD_LEFT)."-".str_pad($p->day, 2, '0', STR_PAD_LEFT);
      } else if(isset($p->date_obtained) && strlen($p->date_obtained) > 0) {
        $date = $p->date_obtained;
      } else {
        $date = '';
      }
      $this->date_obtained = $date;
      $this->fuelcardID = (isset($p->fuelcardID) ? $p->fuelcardID : '');
      $this->CostCentreFK = (isset($p->CostCentreFK) ? $p->CostCentreFK : 0);
    }
    
    function validate() {
		global $invalidFields;
		$invalid = array();

		if(strlen(trim($this->identifier)) > 0) {
			$sql  = 'select vehicleK ';
			$sql .= 'from tblVehicle ';
			$sql .= 'where identifier = \''.dbEscapeString($this->identifier).'\' ';
			$sql .= '  and vehicleK != \''.dbEscapeString($this->vehicleK).'\' ';
			$res = dbQuery($sql);
			if(!$res) {
				debug(dbError($sql));
			} else {
				if(dbNumRows($res) > 0) {
					$invalid['identifier'] = "The Key Tag ID is not unique. A vehicle already exists with this Key Tag ID";
				}
				dbFreeResult($res);
			}
		}
      
		if($this->siteFK == 0) {
			$invalid['siteFK'] = "Please select the current location of the vehicle";
		}

		if($this->modelFK == 0) {
			$invalid['modelFK'] = "Please select the vehicle model";
		}
		
		if($this->CostCentreFK == 0) {
	        $invalid['CostCentreFK'] = "Please select a Cost Centre for this vehicle";
	      }

		//if($this->reference == 0) {
		//	$invalid['reference'] = "Please enter a reference number";
		//} else if(strlen($this->reference) > 60) {
		//	$invalid['reference'] = "Reference no. exeeds the maximum field length";
		//}

		if((!empty($this->year) && !is_numeric($this->year))) {
			$invalid['year'] = "Please enter a valid year for the vehicle";
		} else if(strlen(trim($this->year)) < 4) {
			$invalid['year'] = "Please enter a year for the vehicle. Must be 4 digits.";
		}

		if(strlen(trim($this->date_obtained)) == 0) {
			$invalid['date_obtained'] = "Please select a valid date for Date Obtained [".$this->date_obtained."]";
		} else if(strlen(trim($this->year)) < 4) {
		}

		if((!empty($this->initial_odometer) && !is_numeric($this->initial_odometer))) {
			$invalid['initial_odometer'] = "Please enter a valid odometer reading";
		} else if(strlen(trim($this->initial_odometer)) == 0) {
			$invalid['initial_odometer'] = "Please enter an odometer reading";
		} else if(strlen($this->initial_odometer) > 10) {
			$invalid['initial_odometer'] = "Odometre reading exeeds the maximum field length";
		} else if($this->odometer<0){
			$invalid['initial_odometer'] = "Odometre reading cannot be less than Zero";
		}

		if((!empty($this->seats) && !is_numeric($this->seats))) {
			$invalid['seats'] = "Please enter a valid value for the amount of seats in the vehicle";
		} else if(strlen(trim($this->seats)) == 0) {
			$invalid['seats'] = "Please enter the number of seats in the vehicle";
		} else if(strlen($this->seats) > 2) {
			$invalid['seats'] = "Number of seats exeeds the maximum field length";
		}

		if(strlen(trim($this->colour)) == 0) {
			$invalid['colour'] = "Please enter the colour of the vehicle";
		}else if(is_numeric($this->colour)){
			$invalid['colour'] = "Vehicle colour cannot contain numbers";
		} else if(strlen($this->colour) > 60) {
			$invalid['colour'] = "Colour name exeeds the maximum field length";
		}

		if(count($invalid) > 0) {
      		if(count($invalidFields)==0){
	        	$invalidFields = $invalid; 
	      	} else {
	      		$invalidFields = array_merge($invalidFields, $invalid);
	      	}
        return false;
      }
		return true;
    }
    
    function reset() {
      $this->vehicleK = 0;
      $this->siteFK = 0;
      $this->modelFK = 0;
      $this->identifier = '';
      $this->date_obtained = '';
      //$this->reference = '';
      $this->initial_odometer = '';
      $this->seats = '';
      $this->colour = '';
      $this->year ='';
      $this->tag_id = '';
	  $this->archived = '';
	  $this->fuelcardID = '';
	  $this->CostCentreFK = 0;
    }
    
  }
  
?>