<?php
 /**
*@package OurFleet
*@copyright Copyright 2006 Web Matrix Pty Ltd & e-fficiency Business Solutions
*@version 1.0 
*/

/**
*@version 1.0
*/
  
  date_default_timezone_set ("Australia/Queensland");
  
  function form_start($id, $action, $method, $js_validate='', $target="") {
    global $form_open;
    if(isset($form_open) && $form_open == true) {
      form_close();
      $form_open = false;
    }
    $content  = "<form id='$id' enctype='multipart/form-data' action='$action' method='$method' class='cleanForm' ";
    if(strlen($js_validate) > 0) {
      $content .= " onsubmit='javascript: return $js_validate;' ";
    }
    
    if(strlen($target) > 0) {
     	$content .= " target='$target' ";
    }
    
    $content .= ">";
    $form_open = true;
    return $content;
  }
  
  function form_end() {
    global $form_open;
    $form_open = false;
    return "</form>";
  }
  


  function form_label($id, $label='', $javascript='', $required=false) {
    global $invalidFields;
    if(strlen($label) > 0) {
      if(is_array($invalidFields) && in_array($id, array_keys($invalidFields))) {
        $label = "<label for='$id' class='invalidField' $javascript>".$label;
      } else {
        $label = "<label for='$id' $javascript>".$label;
      }
      if($required){
   		$label .= '<span class="requiredField">*</span>'; 
		}
		$label .= '</label>';
    } else {
      $label = '';
    }
    
    return $label;
  }
  
  function form_textinput($name, $id, $value, $label='', $width='', $maxlength=100, $tooltipsection='',$required=false) {
    $label = form_label($id, $label,'',$required);
    $elem  = "<input type='text' class='text' name='$name' id='$id' value='".htmlspecialchars($value, ENT_QUOTES)."' maxlength='$maxlength'  ";
    if(strlen($width) > 0) {
      $elem .= " style='width: ".$width."px;'";
    }
    $elem .= " />";
    if(strlen(trim($tooltipsection))>0){
    	$elem .= form_tooltip($tooltipsection, $id);
    }
    return $label.$elem."<br/>\n";
  }

  function form_fileupload($name, $id, $label='', $width='', $tooltipsection='', $required='') {
    $label = form_label($id, $label,'',$required);
    $elem  = "<input type='file' class='text' name='$name' id='$id' ";
    if(strlen($width) > 0) {
      $elem .= " style='width: ".$width."px;'";
    }
    $elem .= " />";
    if(strlen(trim($tooltipsection))>0){
    	$elem .= form_tooltip($tooltipsection, $id);
    }
    return $label.$elem."<br/>\n";
  }
  
  function form_passinput($name, $id, $value, $label='', $width='', $tooltipsection='', $required=false) {

    $label = form_label($id, $label,'',$required);
    
    $elem  = "<input type='password' class='password' name='$name' id='$id' value='$value' ";
    if(strlen($width) > 0) {
      $elem .= " style='width: ".$width."px;'";
    }
    $elem .= " />";
    if(strlen(trim($tooltipsection))>0){
    	$elem .= form_tooltip($tooltipsection, $id);
    }
    return $label.$elem."<br/>\n";
  }
  
  function form_select($name, $id, $selected, $fields, $table, $sort, $key, $value, $where='', $onChange='') {
    $content = '';
    $sql  = 'select '.dbEscapeString($fields).' ';
    $sql .= 'from '.dbEscapeString($table).' ';
    if(strlen(trim($where))>0){
    	$sql .= ' where '.dbEscapeString($where).' ';
    }
    $sql .= 'order by '.dbEscapeString($sort);
    $res = dbQuery($sql);
    if(!$res) {
      debug(dbError($sql));
    } else {
      $content  = "<select name='$name' id='$id'";
      if($onChange!=''){
      	$content .= " onchange='" . $onChange . "'";
      }
      $content .= ">\n";
      $content .= "<option value='0'>Select --&gt;</option>";
      while($row = dbFetchAssoc($res)) {
        $content .= "<option value='".$row[$key]."'";
        if($row[$key] == $selected) {
          $content .= " selected";
        }
        if(is_array($value)) {
          $values = array();
          foreach($value as $v) {
            $values[] = $row[$v];
          }
          $content .= ">".implode(" ", $values)."</option>";
        } else {
          $content .= ">".$row[$value]."</option>";
        }
      }
      $content .= "</select>\n";
    }
    return $content;
  }
  
  function form_state_select($name, $id, $selected, $label='', $tooltipsection='', $required=false) {
    $label = form_label($id, $label,'',$required);
    $content = form_select($name, $id, $selected, '*', 'tblState', 'state_abbr asc', 'stateK', 'state_abbr');
    if(strlen(trim($tooltipsection))>0){
    	$content .= form_tooltip($tooltipsection, $id);
    }
    return $label.$content.'<br/>';
  }

   function form_ltype_select($name, $id, $selected, $label='', $tooltipsection='', $required=false) {
    $label = form_label($id, $label,'',$required);
    $content = form_select($name, $id, $selected, '*', 'tblLicenceType', 'typename asc', 'licenceTypeK', 'typename');
    if(strlen(trim($tooltipsection))>0){
    	$content .= form_tooltip($tooltipsection, $id);
    }
    return $label.$content.'<br/>';
  }

  function form_access_select($name, $id, $selected, $label='', $tooltipsection='', $required=false) {
    $label = form_label($id, $label,'',$required);
    $content = form_select($name, $id, $selected, '*', 'tblAccess', 'level asc', 'accessK', array('level', 'name'));
     if(strlen(trim($tooltipsection))>0){
    	$content .= form_tooltip($tooltipsection, $id);
    }
    return $label.$content.'<br/>';
  }

  function form_department_select($name, $id, $selected, $label='', $tooltipsection='', $required = false) {
    $label = form_label($id, $label,'', $required);
    $content = form_select($name, $id, $selected, '*', 'tblDepartment', 'name asc', 'departmentK', 'name');
	 if(strlen(trim($tooltipsection))>0){
    	$content .= form_tooltip($tooltipsection, $id);
    }
    return $label.$content.'<br/>';
  }

  function form_agent_select($name, $id, $selected, $label='', $tooltipsection='', $required=false) {
    $label = form_label($id, $label,'',$required);
    $content = form_select($name, $id, $selected, '*', 'tblAgent', 'name asc', 'agentK', 'name');
	 if(strlen(trim($tooltipsection))>0){
    	$content .= form_tooltip($tooltipsection, $id);
    }
    return $label.$content.'<br/>';
  }

  function form_employee_select($name, $id, $selected, $label='', $tooltipsection='', $required=false, $onChange="") {
    $label = form_label($id, $label,'',$required);
    $content = form_select($name, $id, $selected, '*', 'tblEmployee', 'firstname asc', 'employeeK', array('firstname','lastname'), 'active=1', $onChange);
    if(strlen(trim($tooltipsection))>0){
    	$content .= form_tooltip($tooltipsection, $id);
    }
    return $label.$content.'<br/>';
  }
  
  function form_site_select($name, $id, $selected, $label='', $tooltipsection='', $required=false) {
    $label = form_label($id, $label,'',$required);
    $content = form_select($name, $id, $selected, "siteK, name, city ", "tblSite", "name asc, city asc ", "siteK", "name");
    if(strlen(trim($tooltipsection))>0){
    	$content .= form_tooltip($tooltipsection, $id);
    }
    return $label.$content.'<br/>';
  }
  
  function form_costcentre_select($name, $id, $selected, $label='', $tooltipsection='', $required=false) {
    $label = form_label($id, $label,'',$required);
    $content = form_select($name, $id, $selected, "CostCentreK, name", "tblCostCentre", "name asc", "CostCentreK", "name");
    if(strlen(trim($tooltipsection))>0){
    	$content .= form_tooltip($tooltipsection, $id);
    }
    return $label.$content.'<br/>';
  }
  
  function form_manufacturer_select($name, $id, $selected, $label='', $tooltipsection='', $required=false) {
    $label = form_label($id, $label, '', $required);
    $content = form_select($name, $id, $selected, "manufacturerK, name", "tblManufacturer", "name asc", "manufacturerK", "name");
    if(strlen(trim($tooltipsection))>0){
    	$content .= form_tooltip($tooltipsection, $id);
    }
    return $label.$content.'<br/>';
  }
  
  function form_cartype_select($name, $id, $selected, $label, $tooltipsection='', $required=false) {
    $label = form_label($id, $label,'',$required);
    $content = form_select($name, $id, $selected, 'carTypeK, typename', 'tblCarType', 'typename desc', 'carTypeK', 'typename');
    if(strlen(trim($tooltipsection))>0){
    	$content .= form_tooltip($tooltipsection, $id);
    }
    return $label.$content.'<br/>';
  }

   function form_broker_select($name, $id, $selected, $label, $tooltipsection='', $required=false) {
    $label = form_label($id, $label,'', $required);
    $content = form_select($name, $id, $selected, 'insuranceBrokerK, name', 'tblInsuranceBroker', 'name desc', 'insuranceBrokerK', 'name');
    if(strlen(trim($tooltipsection))>0){
    	$content .= form_tooltip($tooltipsection, $id);
    }
    return $label.$content.'<br/>';
  }
  
 function form_inclusion_select($name, $id, $selected, $label, $tooltipsection='', $required=false) {
    $label = form_label($id, $label,'', $required);
    $content = form_select($name, $id, $selected, 'inclusionK, name', 'tblInclusion', 'name desc', 'inclusionK', 'name');
    if(strlen(trim($tooltipsection))>0){
    	$content .= form_tooltip($tooltipsection, $id);
    }
    return $label.$content.'<br/>';
  }  
  
  function form_bookingreminder_select($name, $id, $selected, $label='', $javascript='', $required=false){
  
  		$label = form_label($id, $label,'',$required);
		$content = '<select name="'.$name.'" id="'.$id.'">';
		$content .= '<option value="">Select --&gt;</option>';
		$content .= '<option value="0"'.($selected==0?' SELECTED':'').'>No Reminder</option>';
		$content .= '<option value="1"'.($selected==1?' SELECTED':'').'>1 Hour</option>';
		$content .= '<option value="5"'.($selected==5?' SELECTED':'').'>5 Hours</option>';
		$content .= '<option value="12"'.($selected==12?' SELECTED':'').'>12 Hours</option>';
		$content .= '<option value="24"'.($selected==24?' SELECTED':'').'>24 Hour</option>';
		$content .= '<option value="48"'.($selected==48?' SELECTED':'').'>2 Days</option>';
		$content .= '<option value="120"'.($selected==120?' SELECTED':'').'>5 Days</option>';
		$content .= '</select>';
		
		return $label.$content.'<br/>';
  }

  function form_AlphaColToNumCol_Select($name, $id, $selected='', $label='', $javascript='', $tooltipsection='', $required=''){
  
  		$label = form_label($id, $label, '', $required);
		$content = '<select name="'.$name.'" id="'.$id.'">';
		$content .= '<option value="">Select --&gt;</option>';
		$select = array(
			"1" => "A",
			"2" => "B",
			"3" => "C",
			"4" => "D",
			"5" => "E",
			"6" => "F",
			"7" => "G",
			"8" => "H",
			"9" => "I",
			"10" => "J",
			"11" => "K",
			"12" => "L",
			"13" => "M",
			"14" => "N",
			"15" => "O",
			"16" => "P",
			"17" => "Q",
			"18" => "R",
			"19" => "S",
			"20" => "T",
			"21" => "U",
			"22" => "V",
			"23" => "W",
			"24" => "X",
			"25" => "Y",
			"26" => "Z"
		);

		foreach($select as $key=> $value) {
			$content .= '<option value="'.$key.'"'.($selected==$key? ' SELECTED':'').'>'.$value.'</option>';
		}

		$content .= '</select>';
		 if(strlen(trim($tooltipsection))>0){
    	$content .= form_tooltip($tooltipsection, $id);
    }
		return $label.$content.'<br/>';
  }
  
	function form_bookingdestination_select($name, $id, $selected, $label='', $javascript='', $required=false){
		$label = form_label($id, $label,'', $required);
		$content = '<select name="'.$name.'" id="'.$id.'" onChange="if(this.value==-2){ge(\'bookDestOtherDiv\').style.display=\'block\';}else{ge(\'bookDestOtherDiv\').style.display=\'none\';};">';
		$content .= '<option value="">Select --&gt;</option>';
		$sql = 'SELECT DISTINCT(destination) FROM tblBooking ORDER BY destination ASC';
		$res = dbQuery($sql);		
		if(!$res) {
      debug(dbError($sql));
    } else {
      while($row = dbFetchAssoc($res)) {
        $content .= "<option value='".$row['destination']."' ".(trim($row['destination'])==trim($selected)?' SELECTED':'').">".$row['destination']."</option>";
      }
    }
		
		$content .= '<option value="-2">Other...</option>';
		$content .= '</select><br/>';
		$content .= '<div id="bookDestOtherDiv" name="bookDestOtherDiv" style="display:none">';
		$content .= '<label for="bookingDestinationText" id="bookingDestinationTextLabel" name="bookingDestinationTextLabel">if other please specify...</label>';
		$content .= "<input type='text' class='text' name='bookingDestinationText' id='bookingDestinationText' value='' maxlength='100' style='width: 200px;'/>";
		$content .= '<br/>';
		$content .= '</div>';
		return $label.$content;
	}  
  
	function form_bookingpurpose_select($name, $id, $selected, $label='', $javascript='', $required){
	 
		$label = form_label($id, $label,'',$required);
		//$content = '<select name="'.$name.'" id="'.$id.'" onChange="if(this.value==-2){ge(\'bookingPurposeText\').style.display=\'block\';ge(\'bookingPurpTextLabel\').style.display=\'block\';}else{ge(\'bookingPurposeText\').style.display=\'none\';ge(\'bookingPurpTextLabel\').style.display=\'none\';};">';
		$content = '<select name="bookingPurposeFK" id="bookingPurposeFK" onChange="if(this.value==-2){ge(\'bookPurpOtherDiv\').style.display=\'block\';}else{ge(\'bookPurpOtherDiv\').style.display=\'none\';};">';
		$content .= '<option value="">Select --&gt;</option>';
		$sql = 'SELECT * FROM tblBookingPurpose WHERE showInList=1 ORDER BY description ASC';
		
		$res = dbQuery($sql);		
		if(!$res) {
      debug(dbError($sql));
    } else {
      while($row = dbFetchAssoc($res)) {
        $content .= "<option value='".$row['bookingPurposeK']."' ".($row['bookingPurposeK']==$selected?' SELECTED':' ').">".$row['description']."</option>";
      }
    }
		
		$content .= '<option value="-2">Other...</option>';
		$content .= '</select><br/>';
		$content .= '<div id="bookPurpOtherDiv" name="bookPurpOtherDiv" style="display:none">';
		$content .= '<label for="bookingPurposeText" id="bookingPurpTextLabel" name="bookingPurpTextLabel">if other please specify...</label>';
		$content .= "<input type='text' class='text' name='bookingPurposeText' id='bookingPurposeText' value='' maxlength='100' style='width: 200px;'/>";
		$content .= '<br/>';
		$content .= '</div>';
		return $label.$content;
	}    
  
	function form_numoccupants_select($name, $id, $selected, $label='', $javascript='', $tooltipsection='', $required=false){
		$label = form_label($id, $label,'', $required);
		$content = '<select name="'.$name.'" id="'.$id.'" '.$javascript.'>';
		for($i=0; $i<13;$i++){
			$content .= '<option value="'.$i.'" '.($selected==$i?'SELECTED':'').'>'.$i.'</option>';
		}
		$content .= '</select>';
		if(strlen(trim($tooltipsection))>0){
    		$content .= form_tooltip($tooltipsection, $id);
    	}
		return $label.$content.'<br/>';
	}  
  
  function form_model_select($name, $id, $selected, $label='', $tooltipsection='', $required=false) {
    $label = form_label($id, $label,'',$required);
    //$content = form_select($name, $id, $selected, "modelK, modelname", "tblModel", "modelname asc", "modelK", "modelname");
    $content  = "<select name='$name' id='$id'>";
    $content .= "<option value='0'>Select --&gt;</option>";
    $sql  = 'select m.modelK, concat(mf.name, " ", m.modelname, " ", ct.typename) as model_name_long ';
    $sql .= 'from tblModel m ';
    $sql .= 'inner join tblManufacturer mf on (m.manufacturerFK = mf.manufacturerK) ';
    $sql .= 'inner join tblCarType ct on (m.carTypeFK = ct.carTypeK) ';
    $res = dbQuery($sql);
    if(!$res) {
      debug(dbError($sql));
    } else {
      while($row = dbFetchAssoc($res)) {
        $content .= "<option value='".$row['modelK']."' ".($row['modelK']==$selected?' SELECTED':'').">".$row['model_name_long']."</option>";
      }
    }
    $content .= "</select>";
    if(strlen(trim($tooltipsection))>0){
    	$content .= form_tooltip($tooltipsection, $id);
    }
    return $label.$content.'<br/>';
  }
  
	function form_vehicle_select($name, $id, $selected, $multirow=false, $multiRowSize=5, $label=''){
		$labelItem = form_label($id, $label);
		
 		$content  = "<select name='$name' id='$id' ".(($multirow)? 'multiple="multiple" SIZE="5"':'').">";
    	$content .= "<option value='0'>Select --&gt;</option>";
		$sql = "SELECT Distinct
											vehicle.vehicleK as vid,
											reg.number as regNum, 
											manuf.name as manName, 
											model.modelname, vehicle.archived
									FROM 
											tblVehicle vehicle 
													INNER JOIN 
											tblModel model ON vehicle.modelFK = model.modelK 
													INNER JOIN 
											tblManufacturer manuf ON model.manufacturerFK = manuf.manufacturerK 
													INNER JOIN 
											tblRego reg ON vehicle.vehicleK = reg.vehicleFK ORDER BY reg.number";
											
		$res = dbQuery($sql);
    	if(!$res) {
      	debug(dbError($sql));
    	} else {
      	while($row = dbFetchAssoc($res)) {
      		if($row['archived']) {
      			$archived = " *";
      		} else {
      			$archived = "";
      		}
        		$content .= "<option value='".$row['vid']."' ".($row['vid']==$selected?' SELECTED':'').">" . $archived . "[".$row['regNum'].'] ' . $row['manName'].' '.$row['modelname']."</option>";
      	}
    	}
    $content .= "</select><br/>";
		
		return $labelItem.$content;
	}  
  
function form_employee_multiselect($name, $id, $selected, $multirow=false, $multiRowSize=5, $label=''){
		$labelItem = form_label($id, $label);
		
 		$content  = "<select name='$name' id='$id' ".(($multirow)? 'multiple="multiple" SIZE="5"':'').">";
    	$content .= "<option value='0'>Select --&gt;</option>";
		$sql = "SELECT * FROM tblEmployee INNER JOIN tblUser ON tblUser.employeeFK = tblEmployee.employeeK WHERE tblEmployee.active=1";
											
		$res = dbQuery($sql);
    	if(!$res) {
      	debug(dbError($sql));
    	} else {
      	while($row = dbFetchAssoc($res)) {
        		$content .= "<option value='".$row['employeeK']."' ".($row['employeeK']==$selected?' SELECTED':'').">".$row['lastname'].', '.$row['firstname']."</option>";
      	}
    	}
    $content .= "</select><br/>";
		
		return $labelItem.$content;
	}    
  
function form_department_multiselect($name, $id, $selected, $multirow=false, $multiRowSize=5, $label=''){
		$labelItem = form_label($id, $label);
		
 		$content  = "<select name='$name' id='$id' ".(($multirow)? 'multiple="multiple" SIZE="5"':'').">";
    	$content .= "<option value='0'>Select --&gt;</option>";
		$sql = "SELECT * FROM tblDepartment ORDER BY name";
											
		$res = dbQuery($sql);
    	if(!$res) {
      	debug(dbError($sql));
    	} else {
      	while($row = dbFetchAssoc($res)) {
        		$content .= "<option value='".$row['departmentK']."' ".($row['departmentK']==$selected?' SELECTED':'').">".$row['name']."</option>";
      	}
    	}
    $content .= "</select><br/>";
		
		return $labelItem.$content;
	}     
  
  function form_hidden($name, $value) {
    return "<input type='hidden' name='$name' value='".htmlspecialchars($value,ENT_QUOTES)."' />";
  }
  
  function form_date_select($name, $id, $value, $label, $tooltipsection='', $required=false) {
    $label = form_label($id, $label,'',$required);
    $content = add_javascript('/js/dateselect.js');
    if($value == '') {
      $value = date('Y-m-d', ts());
    }
    if(config_get('enable_dhtml_dateselect', 1)) {
      //$content .= form_hidden($name, $value);
      $content .= "\n<script type='text/javascript'>DateInput('$name', true,  'YYYY-MM-DD', '$value');</script>\n";
    } else {
      $content .= '<select class="select" id="date_obtained_month">';
      for($i = 1; $i < 13; $i++) {
        $content .= "<option value='$i'>".date('M', mktime(1,1,1,$i, 1, 0))."</option>";
      }
      $content .= '</select>';
      $content .= '<select class="select" id="date_obtained_day">';
      for($i = 1; $i < 32; $i++) {
        $content .= "<option value='$i'>$i</option>";
      }
      $content .= "</select>";
      $content .= '<input type="text" class="text" id="date_obtained_year" size="4" maxlength="4" title="Year" value="'.date('Y').'">';
    }
    if(strlen(trim($tooltipsection))>0){
    	$content .= form_tooltip($tooltipsection, $id);
    }
    $content .= "<br/>";
    return $label.$content;
  }
  
  function form_time_select($name, $id, $selected='', $label, $required=false){
		$label = form_label($id, $label, '',$required);
		$content =  '<select class="select" id="'.$id.'" name="'.$name.'">';
		$hour = 0;
		$content .= '<option value="0">Select --&gt;</option>';
		
		
		for($hour=0;$hour<24;$hour++){
			
			if($hour>11){
				$tempHour = $hour - 12;
				$ampm = ' PM';
			}else{
				$tempHour = $hour;
				$ampm = ' AM';
			}
			
						$tempHour = ($tempHour==0?12:$tempHour);
			
			$tempTime = str_pad($tempHour, 2, '0', STR_PAD_LEFT).':00'.$ampm;
			$content .= '<option value="'.$tempTime.'" '.($selected==$tempTime?'SELECTED':'').'>'.$tempTime.'</option>';
/*
			$tempTime = str_pad($tempHour, 2, '0', STR_PAD_LEFT).':05'.$ampm;
			$content .= '<option value="'.$tempTime.'" '.($selected==$tempTime?'SELECTED':'').'>'.$tempTime.'</option>';
			
			$tempTime = str_pad($tempHour, 2, '0', STR_PAD_LEFT).':10'.$ampm;
			$content .= '<option value="'.$tempTime.'" '.($selected==$tempTime?'SELECTED':'').'>'.$tempTime.'</option>';
*/			
			$tempTime = 	str_pad($tempHour, 2, '0', STR_PAD_LEFT).':15'.$ampm;		
			$content .= '<option value="'.$tempTime.'" '.($selected==$tempTime?'SELECTED':'').'>'.$tempTime.'</option>';
/*			
			$tempTime = str_pad($tempHour, 2, '0', STR_PAD_LEFT).':20'.$ampm;
			$content .= '<option value="'.$tempTime.'" '.($selected==$tempTime?'SELECTED':'').'>'.$tempTime.'</option>';
			
			$tempTime = str_pad($tempHour, 2, '0', STR_PAD_LEFT).':25'.$ampm;
			$content .= '<option value="'.$tempTime.'" '.($selected==$tempTime?'SELECTED':'').'>'.$tempTime.'</option>';
*/			
			$tempTime = 	str_pad($tempHour, 2, '0', STR_PAD_LEFT).':30'.$ampm;		
			$content .= '<option value="'.$tempTime.'" '.($selected==$tempTime?'SELECTED':'').'>'.$tempTime.'</option>';
/*			
			$tempTime = str_pad($tempHour, 2, '0', STR_PAD_LEFT).':35'.$ampm;
			$content .= '<option value="'.$tempTime.'" '.($selected==$tempTime?'SELECTED':'').'>'.$tempTime.'</option>';
			
			$tempTime = str_pad($tempHour, 2, '0', STR_PAD_LEFT).':40'.$ampm;
			$content .= '<option value="'.$tempTime.'" '.($selected==$tempTime?'SELECTED':'').'>'.$tempTime.'</option>';
*/			
			$tempTime = 	str_pad($tempHour, 2, '0', STR_PAD_LEFT).':45'.$ampm;		
			$content .= '<option value="'.$tempTime.'" '.($selected==$tempTime?'SELECTED':'').'>'.$tempTime.'</option>';
/*			
			$tempTime = str_pad($tempHour, 2, '0', STR_PAD_LEFT).':50'.$ampm;
			$content .= '<option value="'.$tempTime.'" '.($selected==$tempTime?'SELECTED':'').'>'.$tempTime.'</option>';
			
			$tempTime = str_pad($tempHour, 2, '0', STR_PAD_LEFT).':55'.$ampm;
			$content .= '<option value="'.$tempTime.'" '.($selected==$tempTime?'SELECTED':'').'>'.$tempTime.'</option>';
*/			
		}
		
		$content .= '</select>';
		$content .='<br/>';
		return $label.$content;
  }

  function form_time2_select($name, $id, $value, $label, $required=false){
	    if($value=='') {
	    	$value = mktime('00', '00', '00', date("n"), date("j"), date("Y") );
	    }
		$label = form_label($id, $label,'',$required);
		$content = form_hidden($name, $value);
		$content .=  '<select class="select" id="'.$id.'_hours" name="'.$name.'_hours">';
		for($hour=0;$hour<12;$hour++){
			if($hour == date('h',$value)) {
				$s = 'selected';
			}else{
				$s = '';
			}
			$content .= '<option '.$s.' value="'.str_pad($hour, 2, '0', STR_PAD_LEFT).'">'.str_pad($hour, 2, '0', STR_PAD_LEFT).'</option>';
			$s = '';
		}
		$content .= '</select> ';
		$content .=  '<select class="select" id="'.$id.'_minutes" name="'.$name.'_minutes">';
		for($min=0;$min<60;$min++){
			if($min == date('i',$value)) {
				$s = 'selected';
			}else{
				$s = '';
			}
			$content .= '<option '.$s.' value="'.str_pad($min, 2, '0', STR_PAD_LEFT).'">'.str_pad($min, 2, '0', STR_PAD_LEFT).'</option>';
			$s = '';
		}
		$content .= '</select>';
		$content .=  '<select class="select" id="'.$id.'_ap" name="'.$name.'_ap">';
			$content .= '<option value="AM">AM</option>';
			$content .= '<option value="PM">PM</option>';
		$content .= '</select>';
		$content .='<br/>';
		
		return $label.$content;
  }


  
  function form_checkbox($name, $id, $value, $label='', $javascript='', $tooltipsection='') {
    $label = form_label($id, $label);
    //$content  = form_hidden($name, 0);
    $content='';
    $content .= "<input type='checkbox' class='checkbox' name='$name' id='$id' value='1' ";
    if($value) {
      $content .= " checked";
    }
    if($javascript){
    	$content .= " ".$javascript;
    }
    $content .= " />\n";
    if(strlen(trim($tooltipsection))>0){
    	$content .= form_tooltip($tooltipsection, $id);
    }
    return $label.$content.'<br/>';
  }
  
	function form_checkbox_value($name, $id, $value, $selected, $label='', $javascript='', $tooltipsection='') {
    $label = form_label($id, $label);
    $content  = form_hidden($name, 0);
    $content .= "<input type='checkbox' class='checkbox' name='$name' id='$id' value='$value' ";
    if($selected) {
      $content .= " checked";
    }
    if($javascript){
    	$content .= " ".$javascript;
    }
    $content .= " />\n";
    if(strlen(trim($tooltipsection))>0){
    	$content .= form_tooltip($tooltipsection, $id);
    }
    return $label.$content.'<br/>';
  }  
  
  function form_textarea($name, $id, $value, $label='', $tooltipsection='', $required=false) {
    $label = form_label($id, $label,'', $required);
    $content  = '';
    $content .= "<br/><textarea name='$name' id='$id' style='width:100%;' rows='6' value='".htmlspecialchars($value,ENT_QUOTES)."'>".htmlspecialchars($value,ENT_QUOTES)."</textarea>\n";
     if(strlen(trim($tooltipsection))>0){
    	$content .= form_tooltip($tooltipsection, $id);
    }
    return $label.$content.'<br/>'    ;
  }
  
  
  function form_submit($name, $text, $style='', $javascript='') {
    return "<input type='submit' value='".htmlspecialchars($text, ENT_QUOTES)."' name='$name' class='submit' ".((strlen($style) > 0) ? "style='$style'" : "")." ".((strlen($javascript) > 0) ? "onclick='return $javascript'" : "")."/>";
  }
  
  function form_reset($name, $text) {
    return "<input type='reset' value='$text' name='$name' class='reset' />";
  }
  
  function form_button_bar($buttons) {
    $content  = "<div align='right' class='buttonBar'>";
    foreach($buttons as $b) {
      $content .= $b."";
    }
    $content .= "</div>";
    
    return $content;
  }
  
  function form_reportduration_select($name, $id, $selected, $label=''){
  		$label = form_label($id, $label);
  		
  		$durations = array(-1=>"Select--&gt;",1=>"Today", 2=>"Tomorrow", 3=>"Next 7 Days", 4=>"Next 14 Days", 5=>"Next 30 Days");
  		
  		$content = '<select class="select" name="'.$name.'" id="'.$id.'">';
      foreach($durations as $key=>$value) {
        $content .= "<option value='$key'>".$value."</option>";
      }
      $content .= '</select><br/>';
      
      return $label.$content;
  }
  
  function form_tooltip($section, $id){
  		global $globalTooltips;
  		if(isset($section) && strlen(trim($section))>0 && isset($id) && strlen(trim($id))>0){
  			if(isset($globalTooltips[$section]) && isset($globalTooltips[$section][$id])){
  				$tooltip = '&nbsp;<img border="0" src="'.theme_dir().'/images/help.gif" onMouseover="hideSelect(\''.$id.'\');ddrivetip(\'<div class=\\\'tooltip\\\'>'.$globalTooltips[$section][$id].'<br/></div>\');" onMouseout="showSelect(\''.$id.'\');hideddrivetip()"/>';
  			}else{
  				$tooltip = '';
  			}
  		}else{
  			$tooltip = '';
  		}
  		return $tooltip;
  }
  
  function form_hidden_label($name, $id, $value, $textvalue, $label, $tooltipsection){
  		$label = form_label($id, $label);
  		$content = '<div class="text">'.$textvalue.'</div>';
  		$content .= form_hidden($name, $value);
  		return $label.$content.'<br/>'; 
  }
  
function form_CardNumberByVehicle_select($name, $id, $selected, $label, $vehicleId, $tooltipsection='', $required=false){
	$label= form_label($id, $label,'',$required);
	
	$sql = 'SELECT DISTINCT card_no FROM tblFuel WHERE vehicleFK='.$vehicleId;
	$content = '<select name="'.$name.'" id="'.$id.'" onChange="if(this.value==-2){ge(\'card_no_textDiv\').style.display=\'block\';}else{ge(\'card_no_textDiv\').style.display=\'none\';}";>';
	$content .= '<option value="">Select --&gt;</option>';
	if(!$res = dbQuery($sql)){
		debug(dbError($sql));
	}else{
		while($cardNum = dbFetchAssoc($res)){
			$content .= "<option value='".$cardNum['card_no']."'>".$cardNum['card_no']."</option>";
		}
	}
	$content .="<option value='-2'>other...</option>";
	$content .= '</select>';
		if(strlen(trim($tooltipsection))>0){
    	$content .= form_tooltip($tooltipsection, $id);
    }
    	$display = $selected==-2?'block':'none';
    	
		$content .='<br/>';
		$content .= '<div id="card_no_textDiv" name="card_no_textDiv" style="display:'.$display.'">';
		$content .= form_label('card_no_text', 'if other, please specify...','',$required);
		//$content .= '<label for="card_no_text" id="bookingPurpTextLabel" name="bookingPurpTextLabel">if other please specify...</label>';
		$content .= "<input type='text' class='text' name='card_no_text' id='card_no_text' value='' maxlength='100' style='width: 200px;'/><br/>";
		$content.='</div>';
	return $label.$content;
}

function form_registrationtype_select($name, $id, $selected, $label='', $tooltipsection='', $required=false) {
    $label = form_label($id, $label,'',$required);
    $content = form_select($name, $id, $selected, '*', 'tblRegistrationType', 'registrationType asc', 'registrationTypeK', 'registrationType');
    if(strlen(trim($tooltipsection))>0){
    	$content .= form_tooltip($tooltipsection, $id);
    }
    return $label.$content.'<br/>';
  }
  
  function form_vehiclesummary($title, $vehicleID){
  		$sql  = 'select v.*, ct.typename, s.name as siteName, r.number , r.regoK';
  $sql .= '      ,concat(man.name, " ", model.modelname, " - ", ct.typename) as model_long_name ';
  $sql .= ', insuranceK as insured ';
  $sql .= 'from tblVehicle v ';
  $sql .= 'inner join tblModel model on (model.modelK = v.modelFK) ';
  $sql .= 'inner join tblManufacturer man on (man.manufacturerK = model.manufacturerFK) ';
  $sql .= 'inner join tblCarType ct on (ct.carTypeK = model.carTypeFK) ';
  $sql .= 'inner join tblSite s on (v.siteFK = s.siteK) ';
  $sql .= 'left outer join tblRego r on (r.vehicleFK = v.vehicleK) ';
  $sql .= 'left outer join tblInsurance i on(v.vehicleK = i.vehicleFK) ';
  	$sql .= 'where v.vehicleK = \''.dbEscapeString($vehicleID).'\' ';
  	$sql .= 'limit 0,1 ';
  	
  	$res = dbQuery($sql);
      if(!$res) {
        debug(dbError($sql));
      } else {
        if(dbNumRows($res) > 0) {
          $row = dbFetchAssoc($res);
          //fix the issue relating to having the time at the end of the date_obtained
			//due to the time the system does not reconise it's date and uses the current system time instead
			$row['date_obtained'] = substr($row['date_obtained'],0,10);         
          $columns = array(
          		array($title, 'vehicledetails')
          );
          $row['vehicledetails'] = $row['colour'].' '.$row['model_long_name'].($row['regoK']?'['.$row['number'].']':'');
          $table = new cTable($columns);
          $table->drawHeader();
          $table->drawRow($row);
          $table->drawFooter();
        } 
        dbFreeResult($res);
  }
  }
  
  function form_FBTYear_select($name, $id, $selected, $label='', $tooltipsection='', $fbtYearsToShow=1) {
  		$label = form_label($id, $label);
  		$content = "<select name='$name' id='$id'>";
  		for($i=0;$i<$fbtYearsToShow+1;$i++){
  			$dateYear = date('Y')-$i;
  			$content .='<option value="'.($dateYear-1).'-'.$dateYear.'">'.($dateYear-1).'-'.$dateYear.'</option>';
		}
  		$content .= '</select>';
  		if(strlen(trim($tooltipsection))>0){
    	$content .= form_tooltip($tooltipsection, $id);
    }
  		return $label.$content.'<br/>';
  }
  
  function form_selltrade_select($name, $id, $selected, $label='', $tooltipsection='', $required=false){
  		$label = form_label($id, $label,'', $required);
  		$content = "<select name='$name' id='$id'>";
  		$content .= '<option value="-1">Select --&gt;</option>';
  		$content .= '<option value="1" '.($selected==1?' SELECTED':'').'>Sold</option>';
  		$content .= '<option value="2" '.($selected==2?' SELECTED':'').'>Traded</option>';
  		$content .= '</select>';
  		
  		return $label.$content.'<br/>';
  }
  

  function form_reportmonth_select($name, $id, $selected, $label='', $required=false){
  		$label = form_label($id, $label, '', $required);
  		
  		$months = array(-1=>"Select--&gt;",1=>"January", 2=>"February", 3=>"March", 4=>"April", 5=>"May", 6=>"June",7=>"July", 8=>"August", 9=>"September", 10=>"October", 11=>"November", 12=>"December");
  		
  		$content = '<select class="select" name="'.$name.'" id="'.$id.'">';
      foreach($months as $key=>$value) {
        $content .= "<option value='$key'";
        if($key==$selected) {
        	$content .= " selected";
        }
        $content .= ">".$value."</option>";
      }
      $content .= '</select><br/>';
      
      return $label.$content;
  }

  function form_reportyear_select($name, $id, $selected, $label='', $tooltipsection='', $YearsToShow=1) {
  		$label = form_label($id, $label);
  		$content = "<select name='$name' id='$id'>";
  		for($i=0;$i<$YearsToShow+1;$i++){
  			$dateYear = date('Y')-$i;
  			$content .='<option value="'.$dateYear.'">'.$dateYear.'</option>';
		}
  		$content .= '</select>';
  		if(strlen(trim($tooltipsection))>0){
    	$content .= form_tooltip($tooltipsection, $id);
    }
  		return $label.$content.'<br/>';
  }
  
  
?>

