<?php
/**
*@package OurFleet
*@copyright Copyright 2006 Web Matrix Pty Ltd & e-fficiency Business Solutions
*@version 1.0 
*/

/**
*@version 1.0
*/

  $new_config = array();
  function config_get($key, $default) {
    global $config, $new_config;
    if(isset($config) && is_array($config) && isset($config[$key])) {
      return $config[$key];
    } else {
      $new_config[$key] = $default;
      $config[$key] = $default;
    }
    return $default;
  }
  
  function config_load() {
    global $config;
    
    $sql  = 'select ckey, cval from tblConfig ';
    $res = dbQuery($sql);
    if(!$res) {
      debug(dbError($sql));
    } else {
      while($row = dbFetchAssoc($res)) {
        $config[$row['ckey']] = $row['cval'];
      }
      dbFreeResult($res);
    }
  }
  
  function config_save() {
    global $new_config;
    if(!is_array($new_config) || count($new_config) == 0) {
      return;
    }
    
    // insert config
    $sql  = 'insert into tblConfig ';
    $sql .= '(ckey, cval, modified_date, modified_by) ';
    $sql .= 'values ';
    $date = ts();
    foreach($new_config as $k=>$v) {
      $inserts[] = "('".$k."', '".$v."','".$date."','1')";
    }
    $sql .= implode(",", $inserts);
    
    $res = dbQuery($sql);
    if(!$res) {
      debug(dbError($sql));
    }
  }
  
  function ts() {
    return time();
  }
  
  function arg($index) {
    if(isset($_GET['a'])) {
      $args = explode("/", $_GET['a']);
      if(isset($args[$index])) {
        return $args[$index];
      } else {
        return false;
      }
    } else {
      return false;
    }
  }
  
  function args() {
    if(isset($_GET['a'])) {
      return $_GET['a'];
    } else {
      return false;
    }
  }
  
  
  function array_to_obj($array, $include_array=true) {
    if(is_array($array)) {
      $obj = new cObjectClass;
      while(list($key, $val) = each($array)) {
      if(is_array($val)){
      	for($i=0;$i<count($val);$i++){
      		$val[$i] = trim(strip_tags($val[$i]));
      	}
      }else{
			$val = trim(strip_tags($val));
		}
        $obj->$key = $val;
        if($include_array) {
          $obj->_values[$key] = $val;
        }
      }
      return $obj;
    } else {
      debug('Trying to create an object from an empty array.');
      return false;
    }
  }
  
  function array_map_to_this($array, &$obj) {
    if(!is_array($array)) {
      debug('Trying to map an empty array to an object.');
      return false;
    }
    while(list($key,$val) = each($array)) {
      if(!is_numeric($key)) {
        $obj->$key = $val;
      }
    }
  }
  
  function debug($msg) {
    global $dbg_messages;
    if(!is_array($dbg_messages)) {
      $dbg_messages = array();
    }
    $dbg_messages[] = $msg;
  }
  
  function debug_messages() {
    global $dbg_messages;
    $output = '';
    if(is_array($dbg_messages) && count($dbg_messages) > 0) {
      $output = theme_warnings($dbg_messages);
      unset($dbg_messages);
    }
    return $output;
  }
  
  function debug_import($import) {
    global $dbg_messages;
    if(is_array($dbg_messages) && is_array($import)) {
      $dbg_messages = array_merge($dbg_messages, $import);
    } else if(!is_array($dbg_messages) && is_array($import)) {
      $dbg_messages = $import;
    } else {
      $dbg_messages[] = $import;
    }
  }
  
  function format_date($from) {
    if(is_numeric($from)) {
      return date(DATE_FORMAT, $from);
    }
  }
  
  function sess_set($key, $val) {
    global $sess;
    $sess->set($key, $val);
  }
  
  function sess_get($key) {
    global $sess;
    return $sess->get($key);
  }
  
  function sess_write() {
    global $sess;
    $sess->write();
  }
  
  function sess_unset($key) {
    global $sess;
    $sess->remove($key);
  }
  
  function access_load_levels() {
    $levels = array();
    $sql = 'select * from tblAccess ';
    $res = dbQuery($sql);
    if(!$res) {
      debug(dbError($sql));
    } else {
      while($row = dbFetchArray($res)) {
        $levels[$row['accessK']] = $row;
      }
      dbFreeResult($res);
    }
    return $levels;
  }

  function internal_error_handler($errno, $errstr, $errfile, $errline, $errcontext) {
    switch ($errno) {
      case E_USER_ERROR:
        echo "<b>My ERROR</b> [$errno] $errstr<br />\n";
        echo "  Fatal error in line $errline of file $errfile";
        echo ", PHP " . PHP_VERSION . " (" . PHP_OS . ")<br />\n";
        echo "Aborting...<br />\n";
        //exit(1);
        break;
      case E_USER_WARNING:
        echo "<b>My WARNING</b> [$errno] $errstr<br />\n";
        break;
      case E_USER_NOTICE:
        echo "<b>My NOTICE</b> [$errno] $errstr<br />\n";
        break;
      default:
        echo "Unknown error type: [$errno] $errstr (".basename($errfile).", $errline, $errcontext)<br />\n";
        break;
    }
    return true;
  }
  
  function setup_error_handler() {
    global $err_handler;
    $err_handler = set_error_handler('internal_error_handler');
  }
  
  function redirect($location) {
    global $dbg_messages;
    if(is_array($dbg_messages) && count($dbg_messages) > 0) {
      sess_set('debug', serialize($dbg_messages));
    }
    sess_write();
    dbClose();
    
    header("Location: $location");
    exit;
  }
  
  function get_department_name($pk) {
    global $departments;
    if($pk == 0) {
      return "-";
    }
    if(isset($departments) && is_array($departments) && isset($departments[$pk])) {
      return $departments[$pk];
    } else {
      $sql = 'select name from tblDepartment where departmentK = \''.dbEscapeString($pk).'\' ';
      $res = dbQuery($sql);
      if(!$res) {
        debug(dbError($sql));
      } else {
        if(dbNumRows($res) > 0) {
          $row = dbFetchAssoc($res);
          dbFreeResult($res);
          return $row['name'];
        } else {
          dbFreeResult($res);
          return "-";
        }
      }
    }
  }
  
  function get_state_name($pk) {
    global $statenames;
    if($pk == 0) {
      return "-";
    }
    
    if(isset($statenames) && is_array($statenames) && isset($statenames[$pk])) {
      return $statenames[$pk];
    } else {
      $sql = 'select state_name from tblState where stateK = \''.dbEscapeString($pk).'\' ';
      $res = dbQuery($sql);
      if(!$res) {
        debug(dbError($sql));
      } else {
        if(dbNumRows($res) > 0) {
          $row = dbFetchAssoc($res);
          dbFreeResult($res);
          return $row['state_name'];
        } else {
          dbFreeResult($res);
          return "-";
        }
      }
    }
  }
  
  function get_user_name($pk) {
    global $usernames;
    if($pk == 0) {
      return "-";
    }
    
    if(isset($usernames) && is_array($usernames) && isset($usernames[$pk])) {
      return $usernames[$pk];
    } else {
      $sql = 'select username from tblState where userK = \''.dbEscapeString($pk).'\' ';
      $res = dbQuery($sql);
      if(!$res) {
        debug(dbError($sql));
      } else {
        if(dbNumRows($res) > 0) {
          $row = dbFetchAssoc($res);
          dbFreeResult($res);
          return $row['username'];
        } else {
          dbFreeResult($res);
          return "-";
        }
      }
    }
  }
  
  function reload_page($removeArgs=false) {
    global $sess;
    $sess->write();
    
    header("Location: ".$_SERVER['REQUEST_URI']);
    exit;
  }
  
  function add_javascript($script) {
    global $scripts;
    if(!isset($scripts) || !is_array($scripts)) {
      $scripts = array();
    }
    if(!in_array($script, $scripts, true)) {
      $scripts[] = $script;
      return "<script type='text/javascript' src='$script'></script>";
    } else {
      return '';
    }
  }
  
  function monthName($monthNumber, $abbrev=false){
  		switch($monthNumber){
  			case 1:
  				$monthName = $abbrev?'Jan':'January';
  				break;
  			case 2:
  				$monthName = $abbrev?'Feb':'February';
  				break;
  			case 3:
  				$monthName = $abbrev?'Mar':'March';
  				break;
  			case 4:
  				$monthName = $abbrev?'Apr':'April';
  				break;
  			case 5:
  				$monthName = $abbrev?'May':'May';
  				break;
  			case 6:
  				$monthName = $abbrev?'Jun':'June';
  				break;
  			case 7:
  				$monthName = $abbrev?'Jul':'July';
  				break;
  			case 8:
  				$monthName = $abbrev?'Aug':'August';
  				break;
  			case 9:
  				$monthName = $abbrev?'Sep':'September';
  				break;
  			case 10:
  				$monthName = $abbrev?'Oct':'October';
  				break;
  			case 11:
  				$monthName = $abbrev?'Nov':'November';
  				break;
  			case 12:
  				$monthName = $abbrev?'Dec':'December';
  				break;
  			default:
  				$monthName = false;
  				break;
  		}
  		return $monthName;
  }
  
  function datediff($interval, $datefrom, $dateto, $using_timestamps = false) {
  /*
    $interval can be:
    yyyy - Number of full years
    q - Number of full quarters
    m - Number of full months
    y - Difference between day numbers
      (eg 1st Jan 2004 is "1", the first day. 2nd Feb 2003 is "33". The datediff is "-32".)
    d - Number of full days
    w - Number of full weekdays
    ww - Number of full weeks
    h - Number of full hours
    n - Number of full minutes
    s - Number of full seconds (default)
  */
  
  if (!$using_timestamps) {
    $datefrom = strtotime($datefrom, 0);
    $dateto = strtotime($dateto, 0);
  }
  $difference = $dateto - $datefrom; // Difference in seconds
  
  switch($interval) {
  
    case 'yyyy': // Number of full years

      $years_difference = floor($difference / 31536000);
      if (mktime(date("H", $datefrom), date("i", $datefrom), date("s", $datefrom), date("n", $datefrom), date("j", $datefrom), date("Y", $datefrom)+$years_difference) > $dateto) {
        $years_difference--;
      }
      if (mktime(date("H", $dateto), date("i", $dateto), date("s", $dateto), date("n", $dateto), date("j", $dateto), date("Y", $dateto)-($years_difference+1)) > $datefrom) {
        $years_difference++;
      }
      $datediff = $years_difference;
      break;

    case "q": // Number of full quarters

      $quarters_difference = floor($difference / 8035200);
      while (mktime(date("H", $datefrom), date("i", $datefrom), date("s", $datefrom), date("n", $datefrom)+($quarters_difference*3), date("j", $dateto), date("Y", $datefrom)) < $dateto) {
        $months_difference++;
      }
      $quarters_difference--;
      $datediff = $quarters_difference;
      break;

    case "m": // Number of full months

      $months_difference = floor($difference / 2678400);
      while (mktime(date("H", $datefrom), date("i", $datefrom), date("s", $datefrom), date("n", $datefrom)+($months_difference), date("j", $dateto), date("Y", $datefrom)) < $dateto) {
        $months_difference++;
      }
      $months_difference--;
      $datediff = $months_difference;
      break;

    case 'y': // Difference between day numbers

      $datediff = date("z", $dateto) - date("z", $datefrom);
      break;

    case "d": // Number of full days

      $datediff = floor($difference / 86400);
      break;

    case "w": // Number of full weekdays

      $days_difference = floor($difference / 86400);
      $weeks_difference = floor($days_difference / 7); // Complete weeks
      $first_day = date("w", $datefrom);
      $days_remainder = floor($days_difference % 7);
      $odd_days = $first_day + $days_remainder; // Do we have a Saturday or Sunday in the remainder?
      if ($odd_days > 7) { // Sunday
        $days_remainder--;
      }
      if ($odd_days > 6) { // Saturday
        $days_remainder--;
      }
      $datediff = ($weeks_difference * 5) + $days_remainder;
      break;

    case "ww": // Number of full weeks

      $datediff = floor($difference / 604800);
      break;

    case "h": // Number of full hours

      $datediff = floor($difference / 3600);
      break;

    case "n": // Number of full minutes

      $datediff = floor($difference / 60);
      break;

    default: // Number of full seconds (default)

      $datediff = $difference;
      break;
  }    

  return $datediff;

}

function rounding($no,$direction)
   {                            
   $skip=0;
   if(!is_float($no)){
   	return $no;
   }
   if(is_float($no) and $direction = 1)
       {
	       
       	$exploded = explode(".",$no);
       	$nrr = $exploded[0]+1;    
       	$skip=1;
       }
 
   if(is_float($no) and $direction = 0){
       $exploded = explode(".",$no);
       $nrr = $exploded[0];        
       $skip=1;
      }
   if(!is_float($no) and $skip ==1) { $nrr = $nrr; } else { $nrr = floor($nrr); }

     return $nrr;
   }
   
function getDepartmentNotification($Department, $nType)   {
	
	
	$sql = 'SELECT Email FROM `tblEmployee` INNER JOIN tblDepartment ON `employeeK` = DepartmentAdminFK INNER JOIN tblUser On EmployeeFK = EmployeeK WHERE departmentK = ' . $Department . ' AND ';
      
	switch($nType) {
  
    	case 'BookingReminders': 

     	$sql.= ' BookingReminders = 1';
      	break;
      	
      	case 'ServicingReminders': 

     	$sql.= ' ServicingReminders = 1';
      	break;
      	
      	case 'BookingNotification': 

     	$sql.= ' BookingNotification = 1';
      	break;
      	
      	case 'AmendmentNotification': 

     	$sql.= ' AmendmentNotification = 1';
      	break;
      	
      	case 'DeletionNotification': 

     	$sql.= ' DeletionNotification = 1';
      	break;
	}
		
	$res = dbQuery($sql);
  	if(!$res) {
    	debug(dbError($sql));
    	return "";
  	} else {
    	if(dbNumRows($res) > 0) {
      		$row = dbFetchAssoc($res);
      		dbFreeResult($res);
      		return $row['Email'];
    	} else {
      		dbFreeResult($res);
      		return "";
    	}
  	}

}
   
?>