<?php
 /**
*@package OurFleet
*@copyright Copyright 2006 Web Matrix Pty Ltd & e-fficiency Business Solutions
*@version 1.0 
*/

/**
*@version 1.0
*/
  
  function theme_dir() {
    global $conf;
    return "/" . config_get('theme_dir','/themes/') . config_get('theme', 'default');
  }
  
  function theme_fs_dir() {
    return $_SERVER['DOCUMENT_ROOT'].theme_dir();
  }
  
  function page_fs_dir() {
    return $_SERVER['DOCUMENT_ROOT']."/pages";
  }
  
  function theme($page) {
    switch($page) {
      case 'login':
      	global $redirect;
        include(theme_fs_dir()."/login.tpl.php");
        break;
      case 'noauth':
      	include(theme_fs_dir()."/noauth.tpl.php");
      	break;
      default:
        global $user,$p,$sess;
        if(file_exists(page_fs_dir()."/".escapeshellcmd($page).".php")) {
          $content = theme_template(page_fs_dir()."/".escapeshellcmd($page).".php", array('p'=>$p,'user'=>$user,'sess'=>$sess));
        }
        include(theme_fs_dir()."/main.tpl.php");
        break;
    }
  }
  
  function theme_header() {
    include_once(theme_fs_dir()."/header.php");
  }
  
  function theme_footer() {
    include_once(theme_fs_dir()."/footer.php");
  }
  
  function theme_menu_title($text) {
    return "<div class='menuTitle'><b>".$text."</b></div>";
  }
  
  function theme_menu_items($items, $class) {
    $content  = '<ul class="'.$class.'">';
    foreach($items as $item) {
      $c = $class;
      if((arg(0) && (arg(0) == $item['args'] || args() == $item['args'])) || (args() == "" && $item['args'] == '')) {
        $c .= " active";
      }
      $url = ($item['args'] == '/') ? '/' : '/?a='.$item['args'];
      $content .= '<li class="'.$c.'"><a href="'.$url.'" alt="'.$item['alt'].'" class="'.$c.'">'.($item['icon']!=''?'<img src="'.theme_dir().'/images/'.$item['icon'].'" border="0"/>&nbsp;':'').$item['text'].'</a></li>';
    }
    $content .= '</ul><br/>';
    
    return $content;
  }
  
  function theme_hmenu() {
    return theme_menu_items(get_hmenu_items(), 'hmenu');
  }
  
  function theme_menu() {
  
    global $user;
    $menu = get_menu();
    
    $content = '';

    foreach($menu as $m) {
      $items = array();
    
    
      if((isset($user) && is_object($user)) && $m['access'] <= $user->access) {
      	
        $use = array();
        foreach($m['items'] as $i) {
          if($i['access'] <= $user->access) {
            $use[] = $i;
          }
        }
        if(count($use) > 0) {
          $content .= theme_menu_title($m['title']);
          $content .= theme_menu_items($use, 'menu');
        }
      }
    }
    
    
    return $content;
  }
  
  function theme_copyright() {

    return "<span class='copyright'>&copy; Natus Software - ".date('Y')."</span>";
  }
  
  function theme_template($file, $vars) {
    extract($vars);
    ob_start();
    include($file);
    $c = ob_get_contents();
    ob_end_clean();
    return $c;
  }
  
  function theme_hlogin() {
    global $p; // post
    return theme_template(theme_fs_dir().'/hlogin.tpl.php', array('p'=>$p));
  }
  
  function theme_hwelcome() {
    global $user;
    return "<div class='hwelcome'>Welcome: <span class='name'>".$user->username."</span> | <a href='?a=feedback'><!--<img src=\"".theme_dir()."/images/logout.png\" border=\"0\"/>-->&nbsp;Feedback</a> | <a href='?process=logout'><img src=\"".theme_dir()."/images/logout.png\" border=\"0\"/>&nbsp;Logout</a></div>";
  }
  
  function theme_warnings($arr) {
    $content = '';
    foreach($arr as $a) {
      $content .= '<div style="padding-left:8px;padding-right:8px;margin-bottom:4px;float:left;">';
      $content .= $a.'<br/>';
      $content .= '</div>';
    }
    return $content;
  }
  
?>